//---------------------------------------------------------------------------
// add libraries to BCB1 help
// load /CBuilder/Help/bcbhelp.cfg,
//   add :INDEX & :LINK fields
// if (modified)
//   save modified bcbhelp.cfg
//   delete files /CBuilder/Help/BCB.GID & /CBuilder/Help/BCB.FTS
// finished

void __fastcall TInstallForm::InstallBCB1Help( int lib )
{
// allocate temporary strings
TStringList* old_strings = new TStringList();
if (!old_strings)
    {
    Error( "\
---------------------------\n\
BCB1 Help File Problem:\n\
---------------------------\n\
\n\
The BCB1 help files cannot be installed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" should install successfully.\n\
\n\
Error Code: BCB1_H1\
\n\
---------------------------\n\
" );
    return;
    }
TStringList* new_strings = new TStringList();
if (!new_strings)
    {
    delete old_strings;
    Error( "\
---------------------------\n\
BCB1 Help File Problem:\n\
---------------------------\n\
\n\
The BCB1 help files cannot be installed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" should install successfully.\n\
\n\
Error Code: BCB1_H2\
\n\
---------------------------\n\
" );
    return;
    }

// some vars used below
bool found_link = false;
bool found_index = false;
int link_index = -1;
int index_index = -1;
int last_link_index = -1;
int last_index_index = -1;
bool inserted_link = false;
bool inserted_index = false;
bool replaced_link = false;
bool replaced_index = false;

// -----------------------------
// load contents of BCBHELP.CFG file
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG" ); }
catch (...)
    {
    // cleanup temporary strings
    delete new_strings;
    delete old_strings;
    Error( "\
---------------------------\n\
BCB1 Help File Problem:\n\
---------------------------\n\
\n\
The BCB1 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because a file normally distributed with BCB1 cannot be read:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG\"\n\
\n\
You may need to reinstall or reconfigure BCB1 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB1_H3\
\n\
---------------------------\n\
" );
    return;
    }

// modify BCBHELP.CFG
try
    {
    // scan all existing rows to see what is already installed
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :INDEX row
        if (st.Pos( ":INDEX" )!=0)
            {
            last_index_index = i;
            // also check for a complete :INDEX TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_index = true;
                index_index =  i;
                }
            }
        // remember the last :LINK row
        if (st.Pos( ":LINK" )!=0)
            {
            last_link_index = i;
            // also check for a complete :LINK TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_link = true;
                link_index =  i;
                break;
                }
            }
        }

    // replace existing :INDEX and :LINK
    if (found_index && found_link)
        for (int i=0;i<old_strings->Count;i++)
            if (i==index_index)
                {
                old_strings->Strings[i] = ":INDEX "+Library_Names[lib]+" v"+Library_Versions[lib]+"="+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP";
                replaced_index = true;
                }
            else
                if (i==link_index)
                    {
                    old_strings->Strings[i] = ":LINK "+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP";
                    replaced_link = true;
                    }

    // replace existing :INDEX only
    if (found_index && !found_link)
        for (int i=0;i<old_strings->Count;i++)
            if (i==index_index)
                {
                old_strings->Strings[i] = ":INDEX "+Library_Names[lib]+" v"+Library_Versions[lib]+"="+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP";
                replaced_index = true;
                break;
                }

    // replace existing :LINK only
    if (!found_index && found_link)
        for (int i=0;i<old_strings->Count;i++)
            if (i==link_index)
                {
                old_strings->Strings[i] = ":LINK "+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP";
                replaced_link = true;
                }

    // now do the actual copy, inserting non-existant :INDEX, :LINK as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        new_strings->Add( old_strings->Strings[i] );
        if (i==last_index_index)
            if (!replaced_index)
                {
                new_strings->Add( ":INDEX "+Library_Names[lib]+" v"+Library_Versions[lib]+"="+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP" );
                inserted_index = true;
                }
        if (i==last_link_index)
            if (!replaced_link)
                {
                new_strings->Add( ":LINK "+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP" );
                inserted_link = true;
                }
        }
    }
catch (...)
    {
    // cleanup temporary strings
    delete new_strings;
    delete old_strings;
    Error( "\
---------------------------\n\
BCB1 Help File Problem:\n\
---------------------------\n\
\n\
The BCB1 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because an error occurred while parsing a file normally distributed with BCB1:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG\"\n\
\n\
You may need to reinstall or reconfigure BCB1 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB1_H4\
\n\
---------------------------\n\
" );
    return;
    }

// save changes to file BCBHelp.CFG
if (replaced_index || replaced_link || inserted_index || inserted_link)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG" );
        }
    catch (...)
        {
        // cleanup temporary strings
        delete new_strings;
        delete old_strings;
        Error( "\
---------------------------\n\
BCB1 Help File Problem:\n\
---------------------------\n\
\n\
The BCB1 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because an error occurred while modifying a file normally distributed with BCB1:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG\"\n\
\n\
This may be due to the file having read-only access rights.\n\
Try changing the access rights on this file before installing.\n\
\n\
You may also need to reinstall or reconfigure BCB1 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB1_H5\
\n\
---------------------------\n\
" );
        return;
        }

// cleanup temporary strings
delete new_strings;
delete old_strings;

// make BCB re-link the HELP by deleting the following files.
DeleteFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCB.GID" );
DeleteFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCB.FTS" );
}