//---------------------------------------------------------------------------
// add libraries to BCB6 help
// load /CBuilder6/Help/bcb6.ohi and /CBuilder6/Help/bcb6.ohl,
//   add :INDEX & :LINK fields
// if (modified)
//   save modified files
//   delete files /CBuilder6/Help/BCB6.GID & /CBuilder6/Help/BCB6.FTS
// finished

void __fastcall TInstallForm::InstallBCB6Help( int lib )
{
// allocate temporary strings
TStringList* old_strings = new TStringList();
if (!old_strings)
    {
    Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files cannot be installed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" should install successfully.\n\
\n\
Error Code: BCB6_H1\
\n\
---------------------------\n\
" );
    return;
    }
TStringList* new_strings = new TStringList();
if (!new_strings)
    {
    delete old_strings;
    Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files cannot be installed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" should install successfully.\n\
\n\
Error Code: BCB6_H2\
\n\
---------------------------\n\
" );
    return;
    }

// some vars used below
bool found_index = false;
bool found_include = false;
int index_index = -1;
int include_index = -1;
int last_index_index = -1;
int last_include_index = -1;
bool inserted_index = false;
bool inserted_include = false;
bool replaced_index = false;
bool replaced_include = false;

// -----------------------------
// load contents of BCB6.OHL file
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL" );
    }
catch (...)
    {
    // cleanup temporary strings
    delete new_strings;
    delete old_strings;
    Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because a file normally distributed with BCB6 cannot be read:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL\"\n\
\n\
You may need to reinstall or reconfigure BCB6 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB6_H3\
\n\
---------------------------\n\
" );
    return;
    }

// modify BCB6.OHI
try
    {
    // scan all existing rows to see what is already installed
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :LINK row
        if (st.Pos( ":LINK" )!=0) // if it exists
            {
            last_include_index = i;
            // also check for a complete :LINK TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_include = true;
                include_index =  i;
                }
            }
        }
    // replace existing :LINK only
    if (found_include)
        for (int i=0;i<old_strings->Count;i++)
            if (i==include_index)
                {
                old_strings->Strings[i] = ":Link "+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".hlp";
                replaced_include = true;
                break;
                }

    // now do the actual copy, inserting non-existant :INCLUDE as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        new_strings->Add( old_strings->Strings[i] );
        if (i==last_include_index)
            if (!replaced_include)
                {
                new_strings->Add( ":Link "+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP" );
                inserted_include = true;
                }
        }
    }
catch (...)
    {
    // cleanup temporary strings
    delete new_strings;
    delete old_strings;
    Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because an error occurred while parsing a file normally distributed with BCB6:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL\"\n\
\n\
You may need to reinstall or reconfigure BCB6 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB6_H4\
\n\
---------------------------\n\
" );
    return;
    }

// save changes to file BCB6.OHL
if (replaced_include || inserted_include)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL" );
        }
    catch (...)
        {
        // cleanup temporary strings
        delete new_strings;
        delete old_strings;
        Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because an error occurred while modifying a file normally distributed with BCB6:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL\"\n\
\n\
This may be due to the file having read-only access rights.\n\
Try changing the access rights on this file before installing.\n\
\n\
You may also need to reinstall or reconfigure BCB6 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB6_H5\
\n\
---------------------------\n\
" );
        return;
        }

// -----------------------------
// load contents of BCB.OHI file
new_strings->Clear();
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI" ); }
catch (...)
    {
    // cleanup temporary strings
    delete new_strings;
    delete old_strings;
    Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because a file normally distributed with BCB6 cannot be read:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI\"\n\
\n\
You may need to reinstall or reconfigure BCB6 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB6_H6\
\n\
---------------------------\n\
" );
    return;
    }

// modify BCB6.OHI
try
    {
    // scan all existing rows to see what is already installed
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :INDEX row
        if (st.Pos( ":INDEX" )!=0)
            {
            last_index_index = i;
            // also check for a complete :INDEX TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_index = true;
                index_index =  i;
                }
            }
        }
    // replace existing :INDEX only
    if (found_index)
        for (int i=0;i<old_strings->Count;i++)
            if (i==index_index)
                {
                old_strings->Strings[i] = ":INDEX "+Library_Names[lib]+" v"+Library_Versions[lib]+"="+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP";
                replaced_index = true;
                break;
                }

    // now do the actual copy, inserting non-existant :INDEX as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        new_strings->Add( old_strings->Strings[i] );
        if (i==last_index_index)
            if (!replaced_index)
                {
                new_strings->Add( ":INDEX "+Library_Names[lib]+" v"+Library_Versions[lib]+"="+TDx_Root_Dir+"\\"+Library_Names[lib]+"\\Help\\"+Library_Names[lib]+".HLP" );
                inserted_index = true;
                }
        }
    }
catch (...)
    {
    // cleanup temporary strings
    delete new_strings;
    delete old_strings;
    Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because an error occurred while parsing a file normally distributed with BCB6:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI\"\n\
\n\
You may need to reinstall or reconfigure BCB6 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB6_H7\
\n\
---------------------------\n\
" );
    return;
    }

// save changes to file
if (replaced_index || inserted_index)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI" );
        }
    catch (...)
        {
        // cleanup temporary strings
        delete new_strings;
        delete old_strings;
        Error( "\
---------------------------\n\
BCB6 Help File Problem:\n\
---------------------------\n\
\n\
The BCB6 help files for the "+Library_Names[lib]+" v"+Library_Versions[lib]+" cannot be installed because an error occurred while modifying a file normally distributed with BCB6:\n\
\n\
  File: \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI\"\n\
\n\
This may be due to the file having read-only access rights.\n\
Try changing the access rights on this file before installing.\n\
\n\
You may also need to reinstall or reconfigure BCB6 to correct this problem.\n\
Once the problem is resolved the "+Library_Names[lib]+" v"+Library_Versions[lib]+" help files should install successfully.\n\
\n\
Error Code: BCB6_H8\
\n\
---------------------------\n\
" );
        return;
        }

// cleanup temporary strings
delete new_strings;
delete old_strings;

// make BCB re-link the HELP by deleting the following files.
DeleteFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.GID" );
DeleteFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.FTS" );
}
