//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "MiscellaneousFunctions.h"
#pragma package(smart_init)
#include "registry.hpp"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "sys\stat.h"
//#include "shlobj.h"
//---------------------------------------------------------------------------
TStrings* ElementStrings( AnsiString SourceText, AnsiString Delimeter )
{
if (SourceText=="") return NULL;
TStrings* strings = new TStringList();
if (strings==NULL) return NULL;

/*
int pos;
int length = Delimeter.Length();
while (pos = SourceText.Pos(Delimeter))
    {
    strings->Add( SourceText.SubString(1,pos-1) );
    SourceText = SourceText.SubString(pos+length,SourceText.Length());
    }
return strings;
*/

char* source = SourceText.c_str();
char* delimeter = Delimeter.c_str();
int len = SourceText.Length();
int delimeter_length = Delimeter.Length();
int delimeter_count = 0;
AnsiString normal_text = "";
AnsiString possibly_normal_text = "";
for (int i=0;i<len;i++)
    {
    if (*source == *delimeter)  // if we found a delimeter
        {
        *delimeter++;           // get ready for the next one
        delimeter_count++;      // and remember how many we've completed
        if (delimeter_count==delimeter_length) // if we found a completed delimeter
            {
            // save the our built-up string
            strings->Add(normal_text);
            normal_text = "";
            possibly_normal_text = "";
            }
        else
            possibly_normal_text += *source;
        }
    else
        {
        normal_text += possibly_normal_text;
        possibly_normal_text = "";
        normal_text += *source;
        delimeter = Delimeter.c_str();
        delimeter_count = 0;
        }
    *source++;
    }
if (normal_text!="") strings->Add(normal_text);
return strings;
}
//---------------------------------------------------------------------------
AnsiString  ElementString( AnsiString SourceText, AnsiString Delimeter, int ElementNumber )
{
TStrings* elems = ElementStrings( SourceText, Delimeter );
if (elems == NULL) return "";
AnsiString str = "";
if ((ElementNumber>=0) && (ElementNumber<=elems->Count-1))
    str = elems->Strings[ElementNumber];
delete elems;
return str;
}
//---------------------------------------------------------------------------
int ElementCount( AnsiString SourceText, AnsiString Delimeter )
{
TStrings* elems = ElementStrings( SourceText, Delimeter );
if (elems == NULL) return 0;
int count = elems->Count;
delete elems;
return count;
}
//---------------------------------------------------------------------------
AnsiString  ReplaceText( AnsiString SourceText,
                         AnsiString ReplaceWhat,
                         AnsiString WithWhat )
{
if (SourceText=="") return "";
if (ReplaceWhat=="") return SourceText;
if (ReplaceWhat==WithWhat) return SourceText;

AnsiString return_string = "";
int iter = 0;
int srce_pos = 1;
while ((srce_pos != 0) && (iter<1000000))
    {
    srce_pos = SourceText.Pos(  ReplaceWhat );
    if (srce_pos!=0)
        {
        return_string = return_string + SourceText.SubString( 1, srce_pos-1 ) + WithWhat;
        SourceText.Delete( 1, srce_pos-1 + ReplaceWhat.Length() );
        }
    else
        return_string = return_string + SourceText;
    iter++;
    }
return return_string;
}
//---------------------------------------------------------------------------
bool FileReplaceText( AnsiString FileName,
                         AnsiString ReplaceWhat,
                         AnsiString WithWhat )
{
if (FileName=="") return false;
if (ReplaceWhat=="") return false;

TStringList* strings = new TStringList();
if (!strings)
    {
    return false;
    }

try {
    strings->LoadFromFile( FileName );
    }
catch (Exception& e)
    {
    return false;
    }

AnsiString SourceText = strings->Text;
AnsiString return_string = "";
int iter = 0;
int srce_pos = 1;
while ((srce_pos != 0) && (iter<1000000))
    {
    srce_pos = SourceText.Pos(  ReplaceWhat );
    if (srce_pos!=0)
        {
        return_string = return_string + SourceText.SubString( 1, srce_pos-1 ) + WithWhat;
        SourceText.Delete( 1, srce_pos-1 + ReplaceWhat.Length() );
        }
    else
        return_string = return_string + SourceText;
    iter++;
    }

if (return_string != SourceText)
    {
    strings->Text = return_string;
    try
        {
        strings->SaveToFile( FileName );
        }
    catch (Exception &e)
        {
        delete strings;
        return false;
        }
    }

delete strings;
return true;
}
//---------------------------------------------------------------------------
bool FileCopy( AnsiString SourcePath, AnsiString DestPath, bool ReplaceExistingFile)
{
BOOL replace = (ReplaceExistingFile) ? TRUE : FALSE;
int result = CopyFile( SourcePath.c_str(), DestPath.c_str(), replace );
return (result!=0);
}
//---------------------------------------------------------------------------
AnsiString GetRootPath( AnsiString pDirectory )
{
if (pDirectory.SubString(1,1)=="\\")
    return GetCurrentDir().SubString(1,3);

if (pDirectory.SubString(1,2)==":\\")
    return GetCurrentDir().SubString(1,3);

if (pDirectory.SubString(2,2)==":\\")
    return pDirectory.SubString(1,3);

return pDirectory;
}
//---------------------------------------------------------------------------
AnsiString GetFolderRelativePath( AnsiString pDirectory )
{
if (pDirectory.SubString(1,1)=="\\")
    return pDirectory.SubString(2,pDirectory.Length()-1);

if (pDirectory.SubString(1,2)==":\\")
    return pDirectory.SubString(3,pDirectory.Length()-2);

if (pDirectory.SubString(2,2)==":\\")
    return pDirectory.SubString(4,pDirectory.Length()-3);

return pDirectory;
}
//---------------------------------------------------------------------------
AnsiString SystemRootDirectory()
{
TRegistry* registry = new TRegistry();
if (registry==NULL) return "";

registry->RootKey = HKEY_LOCAL_MACHINE;
registry->OpenKey( "\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion", false );
AnsiString system_root = registry->ReadString( "SystemRoot" );
delete registry;
return system_root;
}
//---------------------------------------------------------------------------
bool CreateBigDir( AnsiString pDirectory )
{
// determine the root drive of the new directory
AnsiString new_root = GetRootPath(pDirectory);
AnsiString new_folder = GetFolderRelativePath(pDirectory);

// split up directories
TStrings* dirs = ElementStrings( new_folder, "\\" );
if (dirs==NULL) return false;

// save current directory
AnsiString original_directory = GetCurrentDir();

// change to relevant drive's root directory
if (!SetCurrentDir( new_root )) return false;

// traverse the directory and create each subdir as required
bool ok = true;
for (int i=0;i<dirs->Count;i++)
    {
    // if directory does not already exist, create it
    if (!DirectoryExists( dirs->Strings[i])) CreateDir( dirs->Strings[i] );

    // change to the newly created directory
    if (DirectoryExists( dirs->Strings[i] )) SetCurrentDir( dirs->Strings[i] );
    else
        // abort if not created for any reason.
        {
        ok = false;
        break;
        }
    }

// release directory strings
delete dirs;

// restore original directory
SetCurrentDir( original_directory );

// return status
return ok;
}
//---------------------------------------------------------------------------
// eg.  pFolderName = TDx_Library
//      pStartMenuLocation = Programs\TDx_Library
bool CreateStartMenuFolder( AnsiString pStartMenuLocation )
{
if (pStartMenuLocation=="") return false;

// get system folder eg. C:\Windows
AnsiString system_root = SystemRootDirectory();
if (system_root=="") return false;

// make it the start menu eg. C:\Windows\Start Menu
AnsiString start_menu_root = system_root + "\\Start Menu";

// determine entire string. ie. C:\Windows\Start Menu\Programs\TDx_Library
AnsiString new_folder = start_menu_root;
if (pStartMenuLocation.SubString(1,1)!="\\") new_folder = new_folder + "\\";
new_folder = new_folder + pStartMenuLocation;

// create the new folder
return CreateBigDir( new_folder );
}
//---------------------------------------------------------------------------
bool CreateStartMenuLink(AnsiString pStartMenuLocation, AnsiString pLinkName, AnsiString pFileName )
{
/*
AnsiString system_root = SystemRootDirectory();
if (system_root=="") return false;

AnsiString start_menu_root = system_root + "\\Start Menu";
AnsiString link_location = start_menu_root;
if (pStartMenuLocation.SubString(1,1)!="\\") link_location = link_location + "\\";
link_location = link_location + pStartMenuLocation;
link_location = link_location + "\\" + pLinkName;
if (link_location.UpperCase().Pos(".LNK")==0) link_location = link_location + ".LNK";

// initialize COM
CoInitialize( NULL );

// Get a pointer to the IShellLink interface.
IShellLink* shell_link;
HRESULT result = CoCreateInstance( (_GUID) CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER | CLSCTX_LOCAL_SERVER | CLSCTX_INPROC_HANDLER, (_GUID) IID_IShellLink, (void**) &shell_link );
if (SUCCEEDED(result))
    {
    // Query IShellLink for the IPersistFile interface
    // used to save the shortcut in persistent storage.
    IPersistFile* persist_file;
    result = shell_link->QueryInterface( (_GUID)IID_IPersistFile, (void**) &persist_file );
    if (SUCCEEDED(result))
        {
        // set the path to the shortcut target, add a description
        AnsiString filename_directory = ExtractFileDir( pFileName );

        shell_link->SetPath((LPCSTR) pFileName.c_str());
        shell_link->SetDescription((LPSTR) pLinkName.c_str() );
        shell_link->SetWorkingDirectory((LPCSTR) filename_directory.c_str());

        // convert the ansi string to a wide char string
        WORD wide_string[MAX_PATH];
        MultiByteToWideChar(CP_ACP, 0, (LPSTR) link_location.c_str(), -1, (wchar_t*) wide_string, MAX_PATH );

        // Save the link by calling IPersistFile::Save.
        persist_file->Save( (wchar_t*) wide_string, TRUE );

        // release IPersistFile
        persist_file->Release();
        }

    // Release IShellLink
    shell_link->Release();
    }
else
    ShowMessage("FAILED ON SHELL LINK");

// disable COM
CoUninitialize();
*/

return true;
}
//---------------------------------------------------------------------------
void __fastcall Double_Buffer( TWinControl* main_control )
{
// do what can easily be done
main_control->DoubleBuffered = true;

// make all sub-controls double-buffered too.
for (int i=0;i<main_control->ControlCount;i++)
    {
    TControl* sub_control = main_control->Controls[i];
    if (sub_control != NULL)
        {
        TClass temp_class = sub_control->ClassType();
        while (temp_class != NULL)
            {
            AnsiString class_type = String( temp_class->ClassName() );
            if (class_type == "TWinControl")
                {
                TWinControl* win_control = (TWinControl*) sub_control;
                win_control->DoubleBuffered = true;
                break;
                }
            temp_class = temp_class->ClassParent();
            }
        }
    }
}
//---------------------------------------------------------------------------

