//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TErrorForm.h"
#include "TMainForm.h"
#include "TInstallForm.h"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "clipbrd.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDSBufferDesc"
#pragma link "TDx_SoundBuffer"
#pragma resource "*.dfm"
TErrorForm *ErrorForm;
//---------------------------------------------------------------------------
__fastcall TErrorForm::TErrorForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::FormShow(TObject *Sender)
{
Top = MainForm->Top;
Left = MainForm->Left;
Width = MainForm->Width;
Height = MainForm->Height;

if (MainForm->InstallWav->Playing)
    {
    MainForm->InstallWav->Stop();
    was_playing = true;
    }
else
    {
    was_playing = false;
    }

if (MainForm->ErrorWav->Playing) MainForm->ErrorWav->Stop();
MainForm->ErrorWav->Play(0,0);
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::NextClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);
Close();
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::NextMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!Active) return;
TComponent* sender = (TComponent*) Sender;
if (sender==NULL) return;

// if there is an image that is already Highlighted, un-highlight it now.
if ((sender->Name!="Next") && (Highlighted=="Next")) { NextImage->Picture = MainForm->Lo->Picture; Next->Font->Color = clNavy; }

// if the image is not already Highlighted, but now needs to be Highlighted....
if ((sender->Name=="Next") && (Highlighted != "Next")) { NextImage->Picture = MainForm->Hi->Picture; Next->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }

// remember which button is Highlighted
Highlighted = sender->Name;
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::FormPaint(TObject *Sender)
{
Canvas->Brush->Color = clBlack;
Canvas->Brush->Style = bsSolid;
Canvas->FrameRect( ClientRect );
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::FormCreate(TObject *Sender)
{
ErrorMemo->Lines->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::FormHide(TObject *Sender)
{
ErrorMemo->Lines->Clear();
CopiedLabel->Caption = "( Copy text to Clipboard )";
if (was_playing)
    MainForm->InstallWav->Play(0,DSBPLAY_LOOPING);
}
//---------------------------------------------------------------------------


void __fastcall TErrorForm::SpeedButton1Click(TObject *Sender)
{
TClipboard* clip = Clipboard();
clip->AsText = ErrorMemo->Lines->Text;
CopiedLabel->Caption = "( copied )";
CopiedLabel->Update();
Application->HandleMessage();
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::BCBToolsClick(TObject *Sender)
{
MainForm->BCBTools->OnClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TErrorForm::TitleClick(TObject *Sender)
{
MainForm->Title->OnClick(this);
}
//---------------------------------------------------------------------------

