//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TInstallSetupForm.h"
#include "TMainForm.h"
#include "TErrorForm.h"
#include "TInstallForm.h"
#include "MiscellaneousFunctions.h"
#include "registry.hpp"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "sys\stat.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDx_Sound_Library_Install"
#pragma link "TDx_Sound"
#pragma link "TDx_SoundBuffer"
#pragma link "TDSBufferDesc"
#pragma link "PERFGRAP"
#pragma resource "*.dfm"
TInstallSetupForm *InstallSetupForm;
//---------------------------------------------------------------------------
__fastcall TInstallSetupForm::TInstallSetupForm(TComponent* Owner)
        : TForm(Owner)
{
Setup_Defaults = true;
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::FormPaint(TObject *Sender)
{
Canvas->Brush->Color = clBlack;
Canvas->Brush->Style = bsSolid;
Canvas->FrameRect( ClientRect );
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::NextClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);
InstallForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::PrevClick(TObject *Sender)
{
if (MainForm->Prev->Playing) MainForm->Prev->Stop();
MainForm->Prev->Play(0,0);
Close();
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::ExitClick(TObject *Sender)
{
MainForm->Exit->OnClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::NextMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!Active) return;
TComponent* sender = (TComponent*) Sender;
if (sender==NULL) return;

// if there is an image that is already Highlighted, un-highlight it now.
if ((sender->Name!="Next") && (Highlighted=="Next")) { NextImage->Picture = MainForm->Lo->Picture; Next->Font->Color = clNavy; }
else if ((sender->Name!="Prev") && (Highlighted=="Prev")) { PrevImage->Picture = MainForm->Lo->Picture; Prev->Font->Color = clNavy; }
else if ((sender->Name!="FullInstall") && (Highlighted=="FullInstall")) { FullInstallImage->Picture = MainForm->LoSmall->Picture; FullInstall->Font->Color = clNavy; }
else if ((sender->Name!="ReInstall") && (Highlighted=="ReInstall")) { ReInstallImage->Picture = MainForm->LoSmall->Picture; ReInstall->Font->Color = clNavy; }
else if ((sender->Name!="Rebuild") && (Highlighted=="Rebuild")) { RebuildImage->Picture = MainForm->LoSmall->Picture; Rebuild->Font->Color = clNavy; }
else if ((sender->Name!="Exit") && (Highlighted=="Exit")) { ExitImage->Picture = MainForm->Lo->Picture; Exit->Font->Color = clNavy; }

// if the image is not already Highlighted, but now needs to be Highlighted....
if ((sender->Name=="Next") && (Highlighted != "Next")) { NextImage->Picture = MainForm->Hi->Picture; Next->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Prev") && (Highlighted!="Prev")) { PrevImage->Picture = MainForm->Hi->Picture; Prev->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="FullInstall") && (Highlighted!="FullInstall")) { FullInstallImage->Picture = MainForm->HiSmall->Picture; FullInstall->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="ReInstall") && (Highlighted!="ReInstall")) { ReInstallImage->Picture = MainForm->HiSmall->Picture; ReInstall->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Rebuild") && (Highlighted!="Rebuild")) { RebuildImage->Picture = MainForm->HiSmall->Picture; Rebuild->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Exit") && (Highlighted!="Exit")) { ExitImage->Picture = MainForm->Hi->Picture; Exit->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }

// remember which button is Highlighted
Highlighted = sender->Name;
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::UpdateCheckBoxes()
{
Setting_Up_Links = true;

Library_CheckBoxes[DRAW][BCB1] = Draw_1;
Library_CheckBoxes[DRAW][BCB3] = Draw_3;
Library_CheckBoxes[DRAW][BCB4] = Draw_4;
Library_CheckBoxes[DRAW][BCB5] = Draw_5;
Library_CheckBoxes[DRAW][BCB6] = Draw_6;
if (Setup_Defaults)
    {
    Draw->Enabled = Library_Package_Exists[DRAW];
    Draw->Checked = Library_Package_Exists[DRAW];
    }

Library_CheckBoxes[SOUND][BCB1] = Sound_1;
Library_CheckBoxes[SOUND][BCB3] = Sound_3;
Library_CheckBoxes[SOUND][BCB4] = Sound_4;
Library_CheckBoxes[SOUND][BCB5] = Sound_5;
Library_CheckBoxes[SOUND][BCB6] = Sound_6;
if (Setup_Defaults)
    {
    Sound->Enabled = Library_Package_Exists[SOUND];
    Sound->Checked = Library_Package_Exists[SOUND];
    }

Library_CheckBoxes[INPUT][BCB1] = Input_1;
Library_CheckBoxes[INPUT][BCB3] = Input_3;
Library_CheckBoxes[INPUT][BCB4] = Input_4;
Library_CheckBoxes[INPUT][BCB5] = Input_5;
Library_CheckBoxes[INPUT][BCB6] = Input_6;
if (Setup_Defaults)
    {
    Input->Enabled = Library_Package_Exists[INPUT];
    Input->Checked = Library_Package_Exists[INPUT];
    }

Library_CheckBoxes[PLAY][BCB1] = Play_1;
Library_CheckBoxes[PLAY][BCB3] = Play_3;
Library_CheckBoxes[PLAY][BCB4] = Play_4;
Library_CheckBoxes[PLAY][BCB5] = Play_5;
Library_CheckBoxes[PLAY][BCB6] = Play_6;
if (Setup_Defaults)
    {
    Play->Enabled = Library_Package_Exists[PLAY];
    Play->Checked = Library_Package_Exists[PLAY];
    }

Library_CheckBoxes[D3I][BCB1] = d3I_1;
Library_CheckBoxes[D3I][BCB3] = d3I_3;
Library_CheckBoxes[D3I][BCB4] = d3I_4;
Library_CheckBoxes[D3I][BCB5] = d3I_5;
Library_CheckBoxes[D3I][BCB6] = d3I_6;
if (Setup_Defaults)
    {
    d3I->Enabled = Library_Package_Exists[D3I];
    d3I->Checked = Library_Package_Exists[D3I];
    }

Setting_Up_Links = false;

for (int lib=0;lib<NUM_LIBS;lib++)
    {
    bool checked = false;
    switch (lib)
        {
        case DRAW:  checked = Draw->Checked; break;
        case SOUND: checked = Sound->Checked; break;
        case INPUT: checked = Input->Checked; break;
        case PLAY:  checked = Play->Checked; break;
        case D3I:   checked = d3I->Checked; break;
        }

    for (int bcb=0;bcb<NUM_BCB;bcb++)
        {
        // enabled
        Library_CheckBoxes[lib][bcb]->Enabled = BCB_Exists[bcb] && checked;

        // if a library is already installed
        if (Library_Installed[lib][bcb])
            {
            // and the version is the current version
            if (Library_Installed_Version[lib][bcb] == Library_Versions[lib])
                {
                if (Setup_Defaults) Library_CheckBoxes[lib][bcb]->Checked = false;
                if (Library_CheckBoxes[lib][bcb]->Checked)
                    {
                    Library_CheckBoxes[lib][bcb]->Font->Color = clPurple;
                    Library_CheckBoxes[lib][bcb]->Hint = "Overwrite the currently installed "+Library_Names[lib]+" v"+Library_Versions[lib]+" for "+BCB_Names[bcb]+".";
                    Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                    Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Versions[lib]+" reinstall";
                    }
                else
                    {
                    Library_CheckBoxes[lib][bcb]->Font->Color = clNavy;
                    Library_CheckBoxes[lib][bcb]->Hint = "The "+Library_Names[lib]+" v"+Library_Versions[lib]+" is currently installed in "+BCB_Names[bcb]+".";
                    Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                    Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Versions[lib];
                    }
                }
            else
                {
                // an older library version is currently installed....
                // is it v1.4x or v1.5x?
                if ((Library_Installed_Version[lib][bcb] == "1.40") ||
                    (Library_Installed_Version[lib][bcb] == "1.41") ||
                    (Library_Installed_Version[lib][bcb] == "1.42") ||
                    (Library_Installed_Version[lib][bcb] == "1.50") ||
                    (Library_Installed_Version[lib][bcb] == "1.51") ||
                    (Library_Installed_Version[lib][bcb] == "1.52") ||
                    (Library_Installed_Version[lib][bcb] == "1.60") ||
                    (Library_Installed_Version[lib][bcb] == "1.61") ||
                    (Library_Installed_Version[lib][bcb] == "1.62"))
                    {
                    if (Setup_Defaults) Library_CheckBoxes[lib][bcb]->Checked = true;
                    if (Library_CheckBoxes[lib][bcb]->Checked)
                        {
                        Library_CheckBoxes[lib][bcb]->Font->Color = clPurple;
                        Library_CheckBoxes[lib][bcb]->Hint = "Upgrade the "+Library_Names[lib]+" from v"+Library_Installed_Version[lib][bcb]+" to v"+Library_Versions[lib]+".";
                        Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                        Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Installed_Version[lib][bcb]+" upgrade";
                        }
                    else
                        {
                        Library_CheckBoxes[lib][bcb]->Font->Color = clNavy;
                        Library_CheckBoxes[lib][bcb]->Hint = "Do not upgrade the "+Library_Names[lib]+" from v"+Library_Installed_Version[lib][bcb]+" to v"+Library_Versions[lib]+".";
                        Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                        Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Installed_Version[lib][bcb];
                        }
                    }
                else
                    {
                    Library_CheckBoxes[lib][bcb]->Checked = false;
                    Library_CheckBoxes[lib][bcb]->Font->Color = clMaroon;
                    Library_CheckBoxes[lib][bcb]->Hint = "This application cannot upgrade the "+Library_Names[lib]+" from v"+Library_Installed_Version[lib][bcb]+" to v"+Library_Versions[lib]+".";
                    Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                    Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Installed_Version[lib][bcb];
                    }
                }
            }
        else
            {
            // no library is currently installed,
            // if we can install a new library
            if (Library_CheckBoxes[lib][bcb]->Enabled)
                {
                // setup defaults
                if (Setup_Defaults) Library_CheckBoxes[lib][bcb]->Checked = true;
                if (Library_CheckBoxes[lib][bcb]->Checked)
                    {
                    Library_CheckBoxes[lib][bcb]->Font->Color = clGreen;
                    Library_CheckBoxes[lib][bcb]->Hint = "Install the "+Library_Names[lib]+" v"+Library_Versions[lib]+" into "+BCB_Names[bcb]+".";
                    Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                    Library_CheckBoxes[lib][bcb]->Caption = "new install";
                    }
                else
                    {
                    Library_CheckBoxes[lib][bcb]->Font->Color = clNavy;
                    Library_CheckBoxes[lib][bcb]->Hint = "Do not install the "+Library_Names[lib]+" v"+Library_Versions[lib]+" into "+BCB_Names[bcb]+".";
                    Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                    Library_CheckBoxes[lib][bcb]->Caption = "no install";
                    }
                }
            else
                {
                // BCB is not installed, so make it fully unavailable
                Library_CheckBoxes[lib][bcb]->Font->Color = clGray;
                Library_CheckBoxes[lib][bcb]->Hint = "not available";
                Library_CheckBoxes[lib][bcb]->ParentShowHint = false;
                Library_CheckBoxes[lib][bcb]->Caption = "n/a";
                Library_CheckBoxes[lib][bcb]->Checked = false;
                }
            }
        }
    }
Setup_Defaults = false;
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::DrawClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Draw_1->Enabled = Draw->Checked && BCB_Exists[BCB1];
Draw_3->Enabled = Draw->Checked && BCB_Exists[BCB3];
Draw_4->Enabled = Draw->Checked && BCB_Exists[BCB4];
Draw_5->Enabled = Draw->Checked && BCB_Exists[BCB5];
Draw_6->Enabled = Draw->Checked && BCB_Exists[BCB6];
if (Draw->Checked) Draw->Hint = "Install the TDx_Draw_Library components into the selected BCB's.";
else Draw->Hint = "Do not install the TDx_Draw_Library components at this time.";
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::SoundClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Sound_1->Enabled = Sound->Checked && BCB_Exists[BCB1];
Sound_3->Enabled = Sound->Checked && BCB_Exists[BCB3];
Sound_4->Enabled = Sound->Checked && BCB_Exists[BCB4];
Sound_5->Enabled = Sound->Checked && BCB_Exists[BCB5];
Sound_6->Enabled = Sound->Checked && BCB_Exists[BCB6];
if (Sound->Checked) Sound->Hint = "Install the TDx_Sound_Library components into the selected BCB's.";
else Sound->Hint = "Do not install the TDx_Sound_Library components at this time.";
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::InputClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Input_1->Enabled = Input->Checked && BCB_Exists[BCB1];
Input_3->Enabled = Input->Checked && BCB_Exists[BCB3];
Input_4->Enabled = Input->Checked && BCB_Exists[BCB4];
Input_5->Enabled = Input->Checked && BCB_Exists[BCB5];
Input_6->Enabled = Input->Checked && BCB_Exists[BCB6];
if (Input->Checked) Input->Hint = "Install the TDx_Input_Library components into the selected BCB's.";
else Input->Hint = "Do not install the TDx_Input_Library components at this time.";
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::PlayClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Play_1->Enabled = Play->Checked && BCB_Exists[BCB1];
Play_3->Enabled = Play->Checked && BCB_Exists[BCB3];
Play_4->Enabled = Play->Checked && BCB_Exists[BCB4];
Play_5->Enabled = Play->Checked && BCB_Exists[BCB5];
Play_6->Enabled = Play->Checked && BCB_Exists[BCB6];
if (Play->Checked) Play->Hint = "Install the TDx_Play_Library components into the selected BCB's.";
else Play->Hint = "Do not install the TDx_Play_Library components at this time.";
}
//---------------------------------------------------------------------------


void __fastcall TInstallSetupForm::d3IClick(TObject *Sender)
{
if (Setting_Up_Links) return;
d3I_1->Enabled = d3I->Checked && BCB_Exists[BCB1];
d3I_3->Enabled = d3I->Checked && BCB_Exists[BCB3];
d3I_4->Enabled = d3I->Checked && BCB_Exists[BCB4];
d3I_5->Enabled = d3I->Checked && BCB_Exists[BCB5];
d3I_6->Enabled = d3I->Checked && BCB_Exists[BCB6];
if (d3I->Checked) d3I->Hint = "Install the TDx_3DI_Library components into the selected BCB's.";
else d3I->Hint = "Do not install the TDx_3DI_Library components at this time.";
}
//---------------------------------------------------------------------------
void __fastcall TInstallSetupForm::BCBTools_AnimMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
MainForm->BCBTools_AnimMouseMove( this, Shift, X, Y );
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::TitleClick(TObject *Sender)
{
MainForm->Title->OnClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::BCBToolsClick(TObject *Sender)
{
MainForm->BCBTools->OnClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::ExtractFilesClick(TObject *Sender)
{
if (ExtractFiles->Checked) ExtractFiles->Hint = "Extract all files required by all selected libraries";
else ExtractFiles->Hint = "Do not extract any files";
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::InstallComponentsClick(TObject *Sender)
{
if (InstallComponents->Checked) InstallComponents->Hint = "Install essential files for the selected component libraries into selected BCB directories.";
else InstallComponents->Hint = "Do not install essential files";
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::RegisterHelpClick(TObject *Sender)
{
if (RegisterHelp->Checked) RegisterHelp->Hint = "Register (enable) the selected help files for the selected BCB's";
else RegisterHelp->Hint = "Do not register the help files";
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::CopyDirectXClick(TObject *Sender)
{
if (CopyDirectX->Checked) CopyDirectX->Hint = "Backup existing DirectX Include and Lib files, then copy the existing DirectX 7.0a SDK files to relevant C++ Builder directories";
else CopyDirectX->Hint = "Do not copy DirectX Include and Library files to BCB directories";
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::RebuildSourceClick(TObject *Sender)
{
if (RebuildSource->Checked) RebuildSource->Hint = "Rebuild the selected libraries source code before installing";
else RebuildSource->Hint = "Do not rebuild the source code";
}
//---------------------------------------------------------------------------


void __fastcall TInstallSetupForm::FormShow(TObject *Sender)
{
Top = MainForm->Top;
Left = MainForm->Left;
Width = MainForm->Width;
Height = MainForm->Height;

UpdateCheckBoxes();

DrawClick(this);
SoundClick(this);
InputClick(this);
PlayClick(this);
d3IClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::RegisterComponentsClick(TObject *Sender)
{
if (RegisterComponents->Checked) RegisterComponents->Hint = "Register (enable) the selected components for the selected BCB's";
else RegisterComponents->Hint = "Do not register the components";
}
//---------------------------------------------------------------------------


void __fastcall TInstallSetupForm::Draw_1Click(TObject *Sender)
{
UpdateCheckBoxes();
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::FullInstallClick(TObject *Sender)
{
ExtractFiles->Checked = true;
RebuildSource->Checked = false;
InstallComponents->Checked = true;
InstallSource->Checked = true;
RegisterComponents->Checked = true;
RegisterHelp->Checked = true;
CopyDirectX->Checked = true;
//StartMenu->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::RebuildClick(TObject *Sender)
{
ExtractFiles->Checked = false;
RebuildSource->Checked = true;
InstallComponents->Checked = true;
InstallSource->Checked = true;
RegisterComponents->Checked = true;
RegisterHelp->Checked = true;
CopyDirectX->Checked = false;
//StartMenu->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TInstallSetupForm::ReInstallClick(TObject *Sender)
{
ExtractFiles->Checked = false;
RebuildSource->Checked = false;
InstallComponents->Checked = true;
InstallSource->Checked = true;
RegisterComponents->Checked = true;
RegisterHelp->Checked = true;
CopyDirectX->Checked = false;
//StartMenu->Checked = false;
}
//---------------------------------------------------------------------------

