//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TLicenceForm.h"
#include "TMainForm.h"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "clipbrd.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDSBufferDesc"
#pragma link "TDx_SoundBuffer"
#pragma link "tdsbufferdesc"
#pragma link "tdx_soundbuffer"
#pragma resource "*.dfm"
TLicenceForm *LicenceForm;
//---------------------------------------------------------------------------
__fastcall TLicenceForm::TLicenceForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TLicenceForm::FormShow(TObject *Sender)
{
Agreed = false;
CopiedLabel->Caption = "( Copy text to clipboard )";
CopiedLabel->Update();

Top = MainForm->Top;
Left = MainForm->Left;
Width = MainForm->Width;
Height = MainForm->Height;

TempBuffer->CreateFromFile("error.wav", TempBufferDesc, MainForm->Dx_Sound1 );
TempBuffer->Play(0,0);

LicenceListBox->ItemIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TLicenceForm::FormPaint(TObject *Sender)
{
Canvas->Brush->Color = clBlack;
Canvas->Brush->Style = bsSolid;
Canvas->FrameRect( ClientRect );
}
//---------------------------------------------------------------------------

void __fastcall TLicenceForm::FormHide(TObject *Sender)
{
if (TempBuffer->Created) TempBuffer->Destroy();
}
//---------------------------------------------------------------------------

void __fastcall TLicenceForm::CopyPasteButtonClick(TObject *Sender)
{
TClipboard* clip = Clipboard();
clip->AsText = LicenceListBox->Items->Text;
CopiedLabel->Caption = "( Copied )";
CopiedLabel->Update();
}
//---------------------------------------------------------------------------


void __fastcall TLicenceForm::LicenceListBoxKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
// yes/no
if ((Key=='N')||(Key=='n')) { NoClick(this); return; }
if ((Key=='Y')||(Key=='y')) if (Yes->Enabled) { YesClick(this); return; }

// alt-f4
if (Shift.Contains(ssAlt))
    if (Key==VK_F4) { NoClick(this); return; }
// ctrl-f4
if (Shift.Contains(ssCtrl))
    if (Key==VK_F4) { NoClick(this); return; }
}
//---------------------------------------------------------------------------



void __fastcall TLicenceForm::BCBToolsClick(TObject *Sender)
{
MainForm->BCBTools->OnClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TLicenceForm::YesClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);

Agreed = true;
ModalResult = mrOk;
Close();
}
//---------------------------------------------------------------------------

void __fastcall TLicenceForm::NoClick(TObject *Sender)
{
if (MainForm->Prev->Playing) MainForm->Prev->Stop();
MainForm->Prev->Play(0,0);

Agreed = false;
Close();
}
//---------------------------------------------------------------------------

void __fastcall TLicenceForm::ExitClick(TObject *Sender)
{
MainForm->Goodbye->Play(0,0);
while (MainForm->Goodbye->Playing) ;  // wait for end playing
Application->Terminate();
}
//---------------------------------------------------------------------------



void __fastcall TLicenceForm::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
CanClose = true;
}
//---------------------------------------------------------------------------

void __fastcall TLicenceForm::YesMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!Active) return;
TComponent* sender = (TComponent*) Sender;
if (sender==NULL) return;

// if there is an image that is already Highlighted, un-highlight it now.
if ((sender->Name!="Yes") && (Highlighted=="Yes")) { YesImage->Picture = MainForm->Lo->Picture; Yes->Font->Color = clNavy; }
else if ((sender->Name!="No") && (Highlighted=="No")) { NoImage->Picture = MainForm->Lo->Picture; No->Font->Color = clNavy; }
else if ((sender->Name!="Exit") && (Highlighted=="Exit")) { ExitImage->Picture = MainForm->Lo->Picture; Exit->Font->Color = clNavy; }

// if the image is not already Highlighted, but now needs to be Highlighted....
if ((sender->Name=="Yes") && (Highlighted != "Yes")) { YesImage->Picture = MainForm->Hi->Picture; Yes->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="No") && (Highlighted!="No")) { NoImage->Picture = MainForm->Hi->Picture; No->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Exit") && (Highlighted!="Exit")) { ExitImage->Picture = MainForm->Hi->Picture; Exit->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }

// remember which button is Highlighted
Highlighted = sender->Name;
}
//---------------------------------------------------------------------------



