//---------------------------------------------------------------------------
bool        Debugging = false;
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TMainForm.h"
#include "TErrorForm.h"
#include "TInstallForm.h"
#include "TLicenceForm.h"
#include "TUnInstallForm.h"
#include "MiscellaneousFunctions.h"
#include "registry.hpp"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "sys\stat.h"
#include "stdlib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDx_Sound_Library_Install"
#pragma link "TDx_Sound"
#pragma link "TDx_SoundBuffer"
#pragma link "TDSBufferDesc"
#pragma link "PERFGRAP"
#pragma link "tdsbufferdesc"
#pragma link "tdx_sound"
#pragma link "tdx_soundbuffer"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
AnsiString  BCB_Names[NUM_BCB] =                { "BCB1", "BCB3", "BCB4", "BCB5", "BCB6" };
//---------------------------------------------------------------------------
bool        BCB_Exists[NUM_BCB] =               { false, false, false, false, false };
//---------------------------------------------------------------------------
AnsiString  BCB_Keys[NUM_BCB] =                 {
                                                "\\SOFTWARE\\Borland\\C++Builder\\1.0",
                                                "\\SOFTWARE\\Borland\\C++Builder\\3.0",
                                                "\\SOFTWARE\\Borland\\C++Builder\\4.0",
                                                "\\SOFTWARE\\Borland\\C++Builder\\5.0",
                                                "\\SOFTWARE\\Borland\\C++Builder\\6.0"
                                                };
//---------------------------------------------------------------------------
AnsiString  BCB_Root_Dirs[NUM_BCB] =            {
                                                "C:\\Program Files\\Borland\\CBuilder",
                                                "C:\\Program Files\\Borland\\CBuilder3",
                                                "C:\\Program Files\\Borland\\CBuilder4",
                                                "C:\\Program Files\\Borland\\CBuilder5",
                                                "C:\\Program Files\\Borland\\CBuilder6"
                                                };
//---------------------------------------------------------------------------
AnsiString  TDx_Library_Version =               "v1.90";
//---------------------------------------------------------------------------
AnsiString  Library_Names[NUM_LIBS] =           {
                                                "TDx_Draw_Library",
                                                "TDx_Sound_Library",
                                                "TDx_Input_Library",
                                                "TDx_Play_Library",
                                                "TDx_3DI_Library"
                                                };
//---------------------------------------------------------------------------
AnsiString  Library_Abbrevs[NUM_LIBS] =         {
                                                "TDx_Draw",
                                                "TDx_Sound",
                                                "TDx_Input",
                                                "TDx_Play",
                                                "TDx_3DI",
                                                };
//---------------------------------------------------------------------------
AnsiString  Library_Versions[NUM_LIBS] =        {
                                                "1.90",
                                                "1.90",
                                                "1.90",
                                                "1.90",
                                                "1.90"
                                                };
//---------------------------------------------------------------------------
int   Library_Num_Components[NUM_LIBS] =        {
                                                24,
                                                17,
                                                29,
                                                14,
                                                23
                                                };
//---------------------------------------------------------------------------
bool  Library_Installed[NUM_LIBS][NUM_BCB] =    {
                                                { false, false, false, false },
                                                { false, false, false, false },
                                                { false, false, false, false },
                                                { false, false, false, false },
                                                { false, false, false, false }
                                                };
//---------------------------------------------------------------------------
bool  Library_Installed_Help[NUM_LIBS][NUM_BCB] =
                                                {
                                                { false, false, false, false },
                                                { false, false, false, false },
                                                { false, false, false, false },
                                                { false, false, false, false },
                                                { false, false, false, false }
                                                };
//---------------------------------------------------------------------------
AnsiString Library_Installed_Version[NUM_LIBS][NUM_BCB] =
                                                {
                                                { "0.00", "0.00", "0.00", "0.00" },
                                                { "0.00", "0.00", "0.00", "0.00" },
                                                { "0.00", "0.00", "0.00", "0.00" },
                                                { "0.00", "0.00", "0.00", "0.00" },
                                                { "0.00", "0.00", "0.00", "0.00" }
                                                };
//---------------------------------------------------------------------------
bool        Library_Package_Exists[NUM_LIBS] =
                                                {
                                                false,
                                                false,
                                                false,
                                                false,
                                                false
                                                };
//---------------------------------------------------------------------------
AnsiString Library_Component_Names[] =
    {
    "TDx_Draw", "TDx_DrawClipper", "TDx_DrawColorControl", "TDx_DrawGammaControl", "TDx_DrawPalette", "TDx_DrawSurface",
    "TDx_DrawVideoPort", "TDx_DrawVideoPortContainer", "TDDBltFX", "TDDCaps", "TDDColorControl", "TDDColorKey",
    "TDDDeviceIdentifier", "TDDGammaRamp", "TDDOverlayFX", "TDDPixelFormat", "TDDSCaps", "TDDSurfaceDesc",
    "TDDVideoPortBandwidth", "TDDVideoPortCaps", "TDDVideoPortConnect", "TDDVideoPortDesc", "TDDVideoPortInfo", "TDDVideoPortStatus",

    "TDx_Sound", "TDx_SoundBuffer", "TDx_SoundCapture", "TDx_SoundCaptureBuffer", "TDx_SoundKsPropertySet", "TDx_SoundNotify",
    "TDx_Sound3DBuffer", "TDx_Sound3DListener", "TDSCaps", "TDSBCaps", "TDSBufferDesc", "TDSBPositionNotify",
    "TDSCCaps", "TDSCBCaps", "TDSCBufferDesc", "TDS3DBuffer", "TDS3DListener",

    "TDx_Input", "TDx_InputDevice", "TDx_InputEffect", "TDICondition", "TDIConstantForce", "TDICustomForce",
    "TDIDataFormat", "TDIDevCaps", "TDIDeviceInstance", "TDIDeviceObjectData", "TDIDeviceObjectInstance", "TDIEffEscape",
    "TDIEffect", "TDIEffectInfo", "TDIEnvelope", "TDIFileEffect", "TDIJoyState", "TDIJoyState2",
    "TDIKeyboardState", "TDIMouseState", "TDIMouseState2", "TDIObjectDataFormat", "TDIPeriodic", "TDIPropDWORD",
    "TDIPropGuidAndPath", "TDIPropHeader", "TDIPropRange", "TDIPropString", "TDIRampForce",

    "TDx_Play", "TDx_PlayLobby", "TDPAccountDesc", "TDPApplicationDesc", "TDPCaps", "TDPChat",
    "TDPComPortAddress", "TDPCompoundAddressElement", "TDPCredentials", "TDPLAppInfo", "TDPLConnection", "TDPName",
    "TDPSecurityDesc", "TDPSessionDesc",

    "TDx_3D", "TDx_3DDevice", "TDx_3DVertexBuffer",
    "TD3DClipStatus", "TD3DColorValue", "TD3DDeviceDesc", "TD3DDevInfo_TextureManager", "TD3DDevInfo_Texturing",
    "TD3DDP_PtrStride", "TD3DDrawPrimitiveStridedData", "TD3DLight", "TD3DLightingCaps", "TD3DLinePattern",
    "TD3DLVertex", "TD3DMaterial", "TD3DMatrix", "TD3DPrimCaps", "TD3DRect", "TD3DTLVertex", "TD3DVector",
    "TD3DVertex", "TD3DVertexBufferDesc", "TD3DViewPort"
    };
//---------------------------------------------------------------------------
TDateTime   Library_First_Installed[NUM_LIBS][NUM_BCB];
//---------------------------------------------------------------------------

bool        DirectX_Installed = false;
AnsiString  DirectX_Version = "unknown";
AnsiString  DirectX_Root_Dir = "C:\\mssdk";
AnsiString  DirectX_Key = "\\SOFTWARE\\Microsoft\\DirectX";
AnsiString  DirectX_Uninstall_Key = "\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\DirectX 7 SDK";

bool        TDx_Installed = false;
AnsiString  TDx_Root_Dir = "C:\\TDx_Library";
TDateTime   TDx_First_Installed = TDateTime().CurrentDateTime();
AnsiString  TDx_Root_Key = "\\SOFTWARE\\BCB-Tools.com\\TDx_Library";
AnsiString  BCB_Root_Key = "\\SOFTWARE\\BCB-Tools.com";
AnsiString  ASC_Root_Key = "\\SOFTWARE\\A.S.C. Alternate Software Concepts";

bool        ErrorOccurred = false;

AnsiString  DirectX_7_H_Files[NUM_DX7_H_FILES] = {
                "d3d.h", "d3dcaps.h","d3drm.h", "d3drmdef.h", "d3drmobj.h", "d3drmwin.h", "d3dtypes.h",
                "d3dvec.inl", "d3dx.h", "d3dxcore.h", "d3dxerr.h", "d3dxmath.h", "d3dxmath.inl",
                "d3dxshapes.h", "d3dxsprite.h", "ddraw.h", "dinput.h", "dinputd.h", "dls1.h", "dls2.h",
                "dmdls.h", "dmerror.h", "dmksctrl.h", "dmusbuff.h", "dmusicc.h", "dmusicf.h", "dmusici.h",
                "dplay.h", "dplobby.h", "dsetup.h", "dsound.h", "dvp.h", "dxfile.h", "dxsdk.inc",
                "multimon.h", "rmxfguid.h", "rmxftmpl.h", "rmxftmpl.x" };
AnsiString  DirectX_7_Lib_Files[NUM_DX7_LIB_FILES] = {
                "d3dim.lib", "d3drm.lib", "d3dxof.lib", "ddraw.lib", "dinput.lib", "dplayx.lib",
                "dsetup.lib", "dsound.lib", "dxguid.lib" };

AnsiString  Install_Directory = "";

//---------------------------------------------------------------------------
void __fastcall Error( AnsiString ErrorMessage )
{
ErrorOccurred = true;
if (ErrorForm)
    {
    ErrorForm->ErrorMemo->Lines->Clear();
    int pos;
    do
        {
        pos = ErrorMessage.Pos("\n");
        AnsiString Msg = ErrorMessage.SubString(1, pos-1);
        ErrorMessage = ErrorMessage.SubString(pos+1, ErrorMessage.Length());
        ErrorForm->ErrorMemo->Lines->Add( Msg );
        }
    while (pos!=0);
    if (ErrorMessage!="") ErrorForm->ErrorMemo->Lines->Add( ErrorMessage );
    if (!ErrorForm->Visible) ErrorForm->ShowModal();
    }
else
    ShowMessage(ErrorMessage);
}
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
BCBCheck = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ExitClick(TObject *Sender)
{
Goodbye->Play(0,0);
while (Goodbye->Playing) ;  // wait for end playing
Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InstallClick(TObject *Sender)
{
if (Next->Playing) Next->Stop();
Next->Play(0,0);

bool any_installed = false;
for (int lib=0;lib<NUM_LIBS;lib++)
    for (int bcb=0;bcb<NUM_BCB;bcb++)
        any_installed |= (Library_Installed[lib][bcb] && (Library_Installed_Version[lib][bcb] == Library_Versions[lib]));

if (!any_installed)
    {
    LicenceForm->ShowModal();
    if (!LicenceForm->Agreed) return;
    }

InstallForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormPaint(TObject *Sender)
{
Canvas->Brush->Style = bsSolid;
Canvas->Brush->Color = clBlack;
Canvas->FrameRect( ClientRect );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
Width=780;
Height=580;
Application->HintPause = 250;
Application->HintHidePause = 4000;

Install_Directory = GetCurrentDir();
if (Dx_Sound1->Create( NULL ))
    {
    Creak->CreateFromFile("creak.wav",DSBufferDesc1,Dx_Sound1);
    TDx_Library->CreateFromFile("TDx_Library.wav",DSBufferDesc1,Dx_Sound1); // go
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
GetCurrentInstallStatus();
HideShow();

ErrorForm->Caption = MainForm->Caption;
InstallForm->Caption = MainForm->Caption;
LicenceForm->Caption = MainForm->Caption;
UnInstallForm->Caption = MainForm->Caption;

ErrorForm->Title->Caption = MainForm->Title->Caption;
InstallForm->Title->Caption = MainForm->Title->Caption;
LicenceForm->Title->Caption = MainForm->Title->Caption;
UnInstallForm->Title->Caption = MainForm->Title->Caption;

Goodbye->CreateFromFile(Install_Directory+"\\goodbye.wav",DSBufferDesc1,Dx_Sound1);
Completed->CreateFromFile(Install_Directory+"\\completed.wav",DSBufferDesc1,Dx_Sound1);
Pop->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\DDraw\\src\\Donuts\\s_bang.wav",DSBufferDesc1,Dx_Sound1);
Anim->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\DDraw\\src\\Donuts\\level.wav",DSBufferDesc1,Dx_Sound1);
InstallWav->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\DDraw\\src\\Donuts\\hum.wav",DSBufferDesc1,Dx_Sound1);
Next->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\VBSamples\\DXMisc\\src\\SpaceShooter\\Sound\\laser.wav",DSBufferDesc1,Dx_Sound1);
Prev->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\VBSamples\\DXMisc\\src\\SpaceShooter\\Sound\\laser2.wav",DSBufferDesc1,Dx_Sound1);
ErrorWav->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\VBSamples\\DXMisc\\src\\SpaceShooter\\Sound\\powerup.wav",DSBufferDesc1,Dx_Sound1);
AbortWav->CreateFromFile(DirectX_Root_Dir+"\\samples\\Multimedia\\VBSamples\\DXMisc\\src\\SpaceShooter\\Sound\\pulse.wav",DSBufferDesc1,Dx_Sound1);

Timer1->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
while (Goodbye->Playing) ; // do nothing

if (AbortWav->Created) AbortWav->Destroy();
if (ErrorWav->Created) ErrorWav->Destroy();
if (Prev->Created) Prev->Destroy();
if (Next->Created) Next->Destroy();
if (InstallWav->Created) InstallWav->Destroy();
if (Anim->Created) Anim->Destroy();
if (Pop->Created) Pop->Destroy();
if (Completed->Created) Completed->Destroy();
if (Goodbye->Created) Goodbye->Destroy();
if (TDx_Library->Created) TDx_Library->Destroy();
if (Creak->Created) Creak->Destroy();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::UninstallClick(TObject *Sender)
{
Prev->Play(0,0);
}

//---------------------------------------------------------------------------
// This method determines what is currently installed on the computer.
// Steps:
//   (1) create a fresh registry interface
//   (2) determine what versions of BCB exist, and where they are currently
//       located on the users system, usually a local hard disk
//   (3) determine what version of DirectX exists, whether or not the SDK is
//       installed, if it's the Debug Version, and where it exists on the
//       users system.
//   (4) determine if any libraries are installed, the version of each
//       library, where each library is installed, and whether or not the
//       components are currently installed in what versions of BCB.
//   (5) delete the registry interface
//   (6) determine what install packages are currently available.
//   (7) determine if any BCB environments are currently open.
// --------------------------------------------------------------------------
void __fastcall TMainForm::GetCurrentInstallStatus()
{
//   (1) create a fresh registry interface

TRegistry* registry = new TRegistry();
if (registry==NULL)
    {
    Error( "The components cannot be installed because\n\there is not enough memory available to access the system registry." );
    return;
    }


//   (2) determine what versions of BCB exist, and where they are currently
//       located on the users system, usually a local hard disk

registry->RootKey = HKEY_LOCAL_MACHINE;
for (int bcb=0;bcb<NUM_BCB;bcb++)
    {
    BCB_Exists[bcb] = registry->KeyExists( BCB_Keys[bcb] );
    if (BCB_Exists[bcb])
        {
        registry->OpenKey( BCB_Keys[bcb], false );
        BCB_Root_Dirs[bcb] = registry->ReadString( "RootDir" );
        registry->CloseKey();
        }
// djd
if (Debugging) BCB_Exists[bcb] = true;
//if (Debugging) BCB_Exists[BCB5] = false;
//if (Debugging) BCB_Root_Dirs[BCB4] = "Z:\\Program Files\\Borland\\CBuilder4";
// djd
    }

if (BCB_Exists[BCB1])
    {
    BCB1_YesNo->Caption = "YES";
    BCB1_YesNo->Hint = "BCB1 is currently installed";
    BCB1_RootDir->Caption = BCB_Root_Dirs[BCB1];
    BCB1_RootDir->Hint = "The BCB1 Root Directory is "+BCB_Root_Dirs[BCB1];
    }
if (BCB_Exists[BCB3])
    {
    BCB3_YesNo->Caption = "YES";
    BCB3_YesNo->Hint = "BCB3 is currently installed";
    BCB3_RootDir->Caption = BCB_Root_Dirs[BCB3];
    BCB3_RootDir->Hint = "The BCB3 Root Directory is "+BCB_Root_Dirs[BCB3];
    }
if (BCB_Exists[BCB4])
    {
    BCB4_YesNo->Caption = "YES";
    BCB4_YesNo->Hint = "BCB4 is currently installed";
    BCB4_RootDir->Caption = BCB_Root_Dirs[BCB4];
    BCB4_RootDir->Hint = "The BCB4 Root Directory is "+BCB_Root_Dirs[BCB4];
    }
if (BCB_Exists[BCB5])
    {
    BCB5_YesNo->Caption = "YES";
    BCB5_YesNo->Hint = "BCB5 is currently installed";
    BCB5_RootDir->Caption = BCB_Root_Dirs[BCB5];
    BCB5_RootDir->Hint = "The BCB5 Root Directory is "+BCB_Root_Dirs[BCB5];
    }
if (BCB_Exists[BCB6])
    {
    BCB6_YesNo->Caption = "YES";
    BCB6_YesNo->Hint = "BCB6 is currently installed";
    BCB6_RootDir->Caption = BCB_Root_Dirs[BCB6];
    BCB6_RootDir->Hint = "The BCB6 Root Directory is "+BCB_Root_Dirs[BCB6];
    }


//   (3) determine what version of DirectX exists, whether or not the SDK is
//       installed, if it's the Debug Version, and where it exists on the
//       users system.

registry->RootKey = HKEY_LOCAL_MACHINE;
DirectX_Installed = registry->KeyExists( DirectX_Key );
if (DirectX_Installed)
    {
    registry->OpenKey( DirectX_Key, false );
    DirectX_Version = registry->ReadString( "Version" );
    AnsiString temp = registry->ReadString( "DXSDK Doc Path" );
    if (temp!="") DirectX_Root_Dir = ElementString( temp, "\\doc", 0 );
    else
        {
        temp = registry->ReadString( "DXSDK Samples Path" );
        if (temp!="") DirectX_Root_Dir = ElementString( temp, "\\samples", 0 );
        else
            if (registry->KeyExists( DirectX_Uninstall_Key ))
                {
                registry->OpenKey( DirectX_Uninstall_Key, false );
                AnsiString temp = registry->ReadString( "UninstallString" );
                DirectX_Root_Dir = ElementString( ElementString( temp, "\\Uninst.isu", 0 ), "-f", 1 );
                }
            else
                {
                DirectX_Root_Dir = "unknown";
                DirectX_Installed = false;
                }
        }
    registry->CloseKey();
    }
    
if (DirectX_Installed)
    {
    DirectX_YesNo->Caption = "YES";
    DirectX_YesNo->Hint = "The current DirectX configuration was detected successfully";
    DirectX_Installed_Version->Caption = DirectX_Version;
    DirectX_Installed_Version->Hint = "The detected DirectX version is "+DirectX_Version;
    DirectX_70a_YesNo->Caption = (Dx_Sound1->Created) ? "YES" : "NO";
    DirectX_70a_YesNo->Hint = (Dx_Sound1->Created) ? "The current system configuration supports DirectX 7.0a" : "The current system configuration does not support DirectX 7.0a";
    DirectX_RootDir->Caption = DirectX_Root_Dir;
    DirectX_RootDir->Hint = "The DirectX 7.0a SDK was detected at "+DirectX_Root_Dir;
    }
else
    {
    DirectX_YesNo->Caption = "NO";
    DirectX_YesNo->Hint = "The current DirectX configuration was not detected successfully";
    DirectX_Installed_Version->Caption = DirectX_Version;
    DirectX_Installed_Version->Hint = "The detected DirectX version is "+DirectX_Version;
    DirectX_70a_YesNo->Caption = (Dx_Sound1->Created) ? "YES" : "NO";
    DirectX_70a_YesNo->Hint = "The current system configuration supports DirectX 7.0a but does not have the DirectX 7.0a SDK installed.";
    DirectX_RootDir->Caption = DirectX_Root_Dir;
    DirectX_RootDir->Hint = "The DirectX 7.0a SDK was not detected.";
    }



//   (4) determine if any libraries are installed, the version of each
//       library, where each library is installed, and whether or not the
//       components are currently installed in what versions of BCB.

registry->RootKey = HKEY_LOCAL_MACHINE;
TDx_Installed = registry->KeyExists( TDx_Root_Key );

bool any_installed = false;
for (int lib=0;lib<NUM_LIBS;lib++)
    for (int bcb=0;bcb<NUM_BCB;bcb++)
        any_installed |= (Library_Installed[lib][bcb] && (Library_Installed_Version[lib][bcb] == Library_Versions[lib]));

TDx_Installed &= any_installed;

if (TDx_Installed)
    // when !installed, the default settings are used, which results in the
    // settings only being overridden when a custom install occurs
    try
        {
        // determine general TDx_Library information
        registry->OpenKey( TDx_Root_Key, false );
        TDx_Root_Dir = registry->ReadString( "Root_Dir" );
        TDx_First_Installed = registry->ReadDate( "First_Installed" );

        // bugfix... earlier versions left D: with a backslash at the end
        if (TDx_Root_Dir.Pos("\\TDx_Library")==0)
            {
            TDx_Root_Dir.SetLength(2);
            TDx_Root_Dir = TDx_Root_Dir + "\\TDx_Library";
            registry->WriteString( "Root_Dir", TDx_Root_Dir );
            }

        registry->CloseKey();

        TDx_Library_YesNo->Caption = "YES";
        TDx_Library_YesNo->Hint = "The TDx_Library was successfully detected";
        TDx_Library_RootDir->Caption = TDx_Root_Dir;
        TDx_Library_RootDir->Hint = "The install will use this existing directory";

        // determine specific library information
        Libs->Caption = "-";
        Libs->Hint = "No libraries currently installed in any BCB's";
        for (int lib=0;lib<NUM_LIBS;lib++)
            {
            bool installed = false;
            AnsiString installed_into = "";
            for (int bcb=0;bcb<NUM_BCB;bcb++)
                {
                Library_Installed[lib][bcb] = registry->KeyExists( TDx_Root_Key+"\\"+Library_Names[lib] );
                if (Library_Installed[lib][bcb])
                    {
                    registry->OpenKey( TDx_Root_Key+"\\"+Library_Names[lib], false );

                    Library_Installed[lib][bcb]         = (registry->ReadString( BCB_Names[bcb] ) == "True");
                    Library_Installed_Help[lib][bcb]    = (registry->ReadString( BCB_Names[bcb]+"_Help" ) == "True");

                    if (registry->ValueExists( BCB_Names[bcb]+"_First_Installed" ))
                            Library_First_Installed[lib][bcb] = registry->ReadDate( BCB_Names[bcb]+"_First_Installed" );

                    // else handle old versions

                    else if (registry->ValueExists( "First_Installed" )) // old TDx_Library versions
                            Library_First_Installed[lib][bcb] = registry->ReadDate( "First_Installed" );
                        else
                            Library_First_Installed[lib][bcb] = TDx_First_Installed;

                    if (registry->ValueExists( BCB_Names[bcb]+"_Version" ))
                          Library_Installed_Version[lib][bcb] = registry->ReadString( BCB_Names[bcb]+"_Version" );

                    // else handle old versions

                    else
                        if (registry->ValueExists( "Installed_Version" ))
                            Library_Installed_Version[lib][bcb] = registry->ReadString( "Installed_Version" );
                        else
                            Library_Installed_Version[lib][bcb] = "0.00";

                    // done

                    installed |= Library_Installed[lib][bcb];
                    if (Library_Installed[lib][bcb])
                        if (installed_into=="") installed_into = "["+BCB_Names[bcb]+": v"+Library_Installed_Version[lib][bcb]+"]";
                        else installed_into = installed_into + " [" + BCB_Names[bcb]+": v"+Library_Installed_Version[lib][bcb]+"]";

                    registry->CloseKey();
                    }
                }
            if (installed)
                if (Libs->Caption=="-")
                    {
                    Libs->Caption = Library_Names[lib] + "  "+installed_into;
                    Libs->Hint = "The "+Library_Names[lib]+" is currently installed";
                    }
                else
                    {
                    Libs->Caption = Libs->Caption + "\n" + Library_Names[lib] + "  "+installed_into;
                    Libs->Hint = "These libraries are currently installed";
                    }
            }
        }
    catch (...)
        {
        Error( "The registry keys used by the TDx_Library install application have been corrupted.\n\
    This may cause unknown errors when installing or uninstalling the TDx_Library components.\n\
    \n\
    The corrupted information will now be removed, then this application will close.\n\
    You will now need to Restart the install application and re-install any libraries you use or plan to use." );
        registry->DeleteKey( TDx_Root_Key );
        Close();
        }
else
    {
    TDx_First_Installed = TDateTime().CurrentDateTime();

    for (int lib=0;lib<NUM_LIBS;lib++)
        for (int bcb=0;bcb<NUM_BCB;bcb++)
            {
            Library_Installed[lib][bcb] = false;
            Library_Installed_Help[lib][bcb] = false;
            Library_Installed_Version[lib][bcb] = "0.00";
            Library_First_Installed[lib][bcb] = TDx_First_Installed;
            }

    TDx_Library_YesNo->Caption = "NO";
    TDx_Library_YesNo->Hint = "The TDx_Library was not detected";
    TDx_Library_RootDir->Caption = "( new directory ) " + TDx_Root_Dir;
    TDx_Library_RootDir->Hint = "This new directory will be automatically created during the install procedure";
    Libs->Caption = "-";
    Libs->Hint = "No libraries currently installed in any BCB's";
    }


//   (5) delete the registry interface

delete registry;

//   (6) determine what install packages are currently available.

PITS->Caption = "-";
PITS->Hint = "Place the supplied TDx_Library *.PIT files in the same directory as the install";
for (int lib=0;lib<NUM_LIBS;lib++)
    {
    Library_Package_Exists[lib] = FileExists( Install_Directory+"\\"+Library_Names[lib].UpperCase()+".PIT" );
    if (Library_Package_Exists[lib])
        {
        if (PITS->Caption=="-")
            {
            PITS->Caption = Library_Names[lib]+".pit";
            PITS->Hint = "This .pit file contains all the files required by the "+Library_Names[lib]+" v"+Library_Versions[lib];
            }
        else
            {
            PITS->Caption = PITS->Caption + ", " + Library_Names[lib]+".pit";
            PITS->Hint = "These .pit files contain all the files required by individual libraries";
            }
        }
    }

//   (7) determine if any BCB environments are currently open.

//    realtime
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Dx_Sound1Create(TObject *Sender)
{
Dx_Sound1->SetCooperativeLevel( Application->Handle, DSSCL_PRIORITY );
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::RemoveClick(TObject *Sender)
{
if (Prev->Playing) Prev->Stop();
Prev->Play(0,0);
UnInstallForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
if (!Visible) return;
if (!ErrorForm) return;

HideShow();

// simple animation
++Tick %= 40;
int incr = -1;
if (Tick < 20) incr = 1;

SubTitle->Left = SubTitle->Left + incr;
ErrorForm->SubTitle->Left = SubTitle->Left;
LicenceForm->SubTitle->Left = SubTitle->Left;
InstallForm->SubTitle->Left = SubTitle->Left;
UnInstallForm->SubTitle->Left = SubTitle->Left;

if (ErrorForm->Visible) ErrorForm->SubTitle->Update();
else if (LicenceForm->Visible) LicenceForm->SubTitle->Update();
else if (InstallForm->Visible) InstallForm->SubTitle->Update();
else if (UnInstallForm->Visible) UnInstallForm->SubTitle->Update();
else SubTitle->Update();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HideShow()
{
bool bcb_is_open = BCBCheck && (FindWindow("TAppBuilder", NULL) != 0) && !Debugging;
bool bcb_exists = (BCB_Exists[BCB1] || BCB_Exists[BCB3] || BCB_Exists[BCB4] || BCB_Exists[BCB5] || BCB_Exists[BCB6]);
bool dx_exists = DirectX_Installed;
bool both_exists = (bcb_exists && dx_exists);

CloseBCB->Visible = bcb_is_open;
Exit->Visible = true;
ExitHere->Visible = true;
ExitImage->Visible = true;
Actions->Visible = !bcb_is_open && both_exists;
Install->Visible = !bcb_is_open && both_exists;
InstallImage->Visible = !bcb_is_open && both_exists;
Remove->Visible = !bcb_is_open;
RemoveImage->Visible = !bcb_is_open;

if (InstallForm)
    {
    InstallForm->CloseBCB->Visible = bcb_is_open;
    if (InstallForm->installing && bcb_is_open) InstallForm->Abort();
//    InstallForm->Install->Visible = !bcb_is_open && !InstallForm->InstallComplete;
//    InstallForm->InstallImage->Visible = !bcb_is_open && !InstallForm->InstallComplete;
    }

if (UnInstallForm)
    {
    UnInstallForm->CloseBCB->Visible = bcb_is_open;
    if (UnInstallForm->deleting && bcb_is_open) UnInstallForm->Abort();
//    UnInstallForm->Install->Visible = !bcb_is_open && !UnInstallForm->RemoveComplete;
//    UnInstallForm->InstallImage->Visible = !bcb_is_open && !UnInstallForm->RemoveComplete;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BCBTools_AnimMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (Anim->Created && !Anim->Playing) Anim->Play( 0, 0 );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BCBToolsClick(TObject *Sender)
{
TRegistry* registry = new TRegistry();
if (registry)
    {
    registry->RootKey = HKEY_LOCAL_MACHINE;
    if (registry->KeyExists( "SOFTWARE\\CLASSES\\Applications\\iexplore.exe\\shell\\open\\command" ))
        {
        if (Creak->Playing) Creak->Stop();
        Creak->Play(0,0);
        registry->OpenKey( "SOFTWARE\\CLASSES\\Applications\\iexplore.exe\\shell\\open\\command", false );
        AnsiString string = registry->ReadString( "" );
        registry->CloseKey();
        string = ReplaceText( string, "%1", "http://www.tdxlibrary.org" );
        system( string.c_str() );
        }
    delete registry;
    }
}
//---------------------------------------------------------------------------




void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
CanClose = true;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::InstallMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!Active) return;
TComponent* sender = (TComponent*) Sender;
if (sender==NULL) return;

// if there is an image that is already Highlighted, un-highlight it now.
if ((sender->Name!="Install") && (Highlighted=="Install")) { InstallImage->Picture = Lo->Picture; Install->Font->Color = clNavy; }
else if ((sender->Name!="Remove") && (Highlighted=="Remove")) { RemoveImage->Picture = Lo->Picture; Remove->Font->Color = clNavy; }
else if ((sender->Name!="Exit") && (Highlighted=="Exit")) { ExitImage->Picture = Lo->Picture; Exit->Font->Color = clNavy; }

// if the image is not already Highlighted, but now needs to be Highlighted....
if ((sender->Name=="Install") && (Highlighted != "Install")) { InstallImage->Picture = Hi->Picture; Install->Font->Color = clWhite; if (Pop->Playing) Pop->Stop(); Pop->Play(0,0); }
else if ((sender->Name=="Remove") && (Highlighted!="Remove")) { RemoveImage->Picture = Hi->Picture; Remove->Font->Color = clWhite; if (Pop->Playing) Pop->Stop(); Pop->Play(0,0); }
else if ((sender->Name=="Exit") && (Highlighted!="Exit")) { ExitImage->Picture = Hi->Picture; Exit->Font->Color = clWhite; if (Pop->Playing) Pop->Stop(); Pop->Play(0,0); }

// remember which button is Highlighted
Highlighted = sender->Name;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::TitleClick(TObject *Sender)
{
if (!TDx_Library->Playing) TDx_Library->Play(0,0);
}
//---------------------------------------------------------------------------







