//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TUnInstallSetupForm.h"
#include "TMainForm.h"
#include "TErrorForm.h"
#include "TUnInstallForm.h"
#include "MiscellaneousFunctions.h"
#include "registry.hpp"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "sys\stat.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDx_Sound_Library_Install"
#pragma link "TDx_Sound"
#pragma link "TDx_SoundBuffer"
#pragma link "TDSBufferDesc"
#pragma link "PERFGRAP"
#pragma resource "*.dfm"
TUnInstallSetupForm *UnInstallSetupForm;
//---------------------------------------------------------------------------
__fastcall TUnInstallSetupForm::TUnInstallSetupForm(TComponent* Owner)
        : TForm(Owner)
{
Setting_Up_Links = false;
Setup_Defaults = true;
Quiet = false;
}
//---------------------------------------------------------------------------
void __fastcall TUnInstallSetupForm::FormPaint(TObject *Sender)
{
Canvas->Brush->Color = clBlack;
Canvas->Brush->Style = bsSolid;
Canvas->FrameRect( ClientRect );
}
//---------------------------------------------------------------------------
void __fastcall TUnInstallSetupForm::NextClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);
UnInstallForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TUnInstallSetupForm::PrevClick(TObject *Sender)
{
if (MainForm->Prev->Playing) MainForm->Prev->Stop();
MainForm->Prev->Play(0,0);
Close();
}
//---------------------------------------------------------------------------
void __fastcall TUnInstallSetupForm::ExitClick(TObject *Sender)
{
MainForm->Exit->OnClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::NextMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!Active) return;
TComponent* sender = (TComponent*) Sender;
if (sender==NULL) return;

// if there is an image that is already Highlighted, un-highlight it now.
if ((sender->Name!="Next") && (Highlighted=="Next")) { NextImage->Picture = MainForm->Lo->Picture; Next->Font->Color = clNavy; }
else if ((sender->Name!="Prev") && (Highlighted=="Prev")) { PrevImage->Picture = MainForm->Lo->Picture; Prev->Font->Color = clNavy; }
else if ((sender->Name!="Exit") && (Highlighted=="Exit")) { ExitImage->Picture = MainForm->Lo->Picture; Exit->Font->Color = clNavy; }

// if the image is not already Highlighted, but now needs to be Highlighted....
if ((sender->Name=="Next") && (Highlighted != "Next")) { NextImage->Picture = MainForm->Hi->Picture; Next->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Prev") && (Highlighted!="Prev")) { PrevImage->Picture = MainForm->Hi->Picture; Prev->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Exit") && (Highlighted!="Exit")) { ExitImage->Picture = MainForm->Hi->Picture; Exit->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }

// remember which button is Highlighted
Highlighted = sender->Name;
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::UpdateCheckBoxes()
{
Setting_Up_Links = true;

Library_CheckBoxes[DRAW][BCB1] = Draw_1;
Library_CheckBoxes[DRAW][BCB3] = Draw_3;
Library_CheckBoxes[DRAW][BCB4] = Draw_4;
Library_CheckBoxes[DRAW][BCB5] = Draw_5;
Library_CheckBoxes[DRAW][BCB6] = Draw_6;
if (Setup_Defaults)
    {
    Draw->Enabled = Library_Installed[DRAW][BCB1] ||
                    Library_Installed[DRAW][BCB3] ||
                    Library_Installed[DRAW][BCB4] ||
                    Library_Installed[DRAW][BCB5] ||
                    Library_Installed[DRAW][BCB6];
    Draw->Checked = Draw->Enabled;
    }

Library_CheckBoxes[SOUND][BCB1] = Sound_1;
Library_CheckBoxes[SOUND][BCB3] = Sound_3;
Library_CheckBoxes[SOUND][BCB4] = Sound_4;
Library_CheckBoxes[SOUND][BCB5] = Sound_5;
Library_CheckBoxes[SOUND][BCB6] = Sound_6;
if (Setup_Defaults)
    {
    Sound->Enabled = Library_Installed[SOUND][BCB1] ||
                     Library_Installed[SOUND][BCB3] ||
                     Library_Installed[SOUND][BCB4] ||
                     Library_Installed[SOUND][BCB5] ||
                     Library_Installed[SOUND][BCB6];
    Sound->Checked = Sound->Enabled;
    }

Library_CheckBoxes[INPUT][BCB1] = Input_1;
Library_CheckBoxes[INPUT][BCB3] = Input_3;
Library_CheckBoxes[INPUT][BCB4] = Input_4;
Library_CheckBoxes[INPUT][BCB5] = Input_5;
Library_CheckBoxes[INPUT][BCB6] = Input_6;
if (Setup_Defaults)
    {
    Input->Enabled = Library_Installed[INPUT][BCB1] ||
                     Library_Installed[INPUT][BCB3] ||
                     Library_Installed[INPUT][BCB4] ||
                     Library_Installed[INPUT][BCB5] ||
                     Library_Installed[INPUT][BCB6];
    Input->Checked = Input->Enabled;
    }

Library_CheckBoxes[PLAY][BCB1] = Play_1;
Library_CheckBoxes[PLAY][BCB3] = Play_3;
Library_CheckBoxes[PLAY][BCB4] = Play_4;
Library_CheckBoxes[PLAY][BCB5] = Play_5;
Library_CheckBoxes[PLAY][BCB6] = Play_6;
if (Setup_Defaults)
    {
    Play->Enabled = Library_Installed[PLAY][BCB1] ||
                    Library_Installed[PLAY][BCB3] ||
                    Library_Installed[PLAY][BCB4] ||
                    Library_Installed[PLAY][BCB5] ||
                    Library_Installed[PLAY][BCB6];
    Play->Checked = Play->Enabled;
    }

Library_CheckBoxes[D3I][BCB1] = d3I_1;
Library_CheckBoxes[D3I][BCB3] = d3I_3;
Library_CheckBoxes[D3I][BCB4] = d3I_4;
Library_CheckBoxes[D3I][BCB5] = d3I_5;
Library_CheckBoxes[D3I][BCB6] = d3I_6;
if (Setup_Defaults)
    {
    d3I->Enabled = Library_Installed[D3I][BCB1] ||
                   Library_Installed[D3I][BCB3] ||
                   Library_Installed[D3I][BCB4] ||
                   Library_Installed[D3I][BCB5] ||
                   Library_Installed[D3I][BCB6];
    d3I->Checked = d3I->Checked;
    }

Setting_Up_Links = false;

for (int lib=0;lib<NUM_LIBS;lib++)
    {
    bool checked = false;
    switch (lib)
        {
        case DRAW:  checked = Draw->Checked; break;
        case SOUND: checked = Sound->Checked; break;
        case INPUT: checked = Input->Checked; break;
        case PLAY:  checked = Play->Checked; break;
        case D3I:   checked = d3I->Checked; break;
        }

    for (int bcb=0;bcb<NUM_BCB;bcb++)
        {
        // if the library is already installed
        if (Library_Installed[lib][bcb])
            {
            // if BCB exists and the library exists, enable the relevant option
            Library_CheckBoxes[lib][bcb]->Enabled = BCB_Exists[bcb] && checked;

            // and the version is the current version
            if ((Library_Installed_Version[lib][bcb] == Library_Versions[lib]) ||
                (Library_Installed_Version[lib][bcb] == "1.40") ||
                (Library_Installed_Version[lib][bcb] == "1.41") ||
                (Library_Installed_Version[lib][bcb] == "1.42") ||
                (Library_Installed_Version[lib][bcb] == "1.50") ||
                (Library_Installed_Version[lib][bcb] == "1.51") ||
                (Library_Installed_Version[lib][bcb] == "1.52") ||
                (Library_Installed_Version[lib][bcb] == "1.60") ||
                (Library_Installed_Version[lib][bcb] == "1.61") ||
                (Library_Installed_Version[lib][bcb] == "1.62") ||
                (Library_Installed_Version[lib][bcb] == "1.70"))
                {
                Library_CheckBoxes[lib][bcb]->Font->Color = clNavy;
                Library_CheckBoxes[lib][bcb]->Hint = "Remove the "+Library_Names[lib]+" v"+Library_Versions[lib]+" from "+BCB_Names[bcb]+".";
                Library_CheckBoxes[lib][bcb]->ParentShowHint = true;
                Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Versions[lib];
                if (Setup_Defaults) Library_CheckBoxes[lib][bcb]->Checked = true;
                }
            else
                {
                // an older library version is currently installed
                Library_CheckBoxes[lib][bcb]->Font->Color = clGray;
                Library_CheckBoxes[lib][bcb]->Hint = "cannot remove";
                Library_CheckBoxes[lib][bcb]->ParentShowHint = false;
                Library_CheckBoxes[lib][bcb]->Caption = "v"+Library_Installed_Version[lib][bcb];
                Library_CheckBoxes[lib][bcb]->Checked = false;
                }
            }
        else
            {
            // no library is currently installed
            Library_CheckBoxes[lib][bcb]->Enabled = false;
            Library_CheckBoxes[lib][bcb]->Font->Color = clGray;
            Library_CheckBoxes[lib][bcb]->Hint = "not installed";
            Library_CheckBoxes[lib][bcb]->ParentShowHint = false;
            Library_CheckBoxes[lib][bcb]->Caption = "n/a";
            Library_CheckBoxes[lib][bcb]->Checked = false;
            }
        }
    }
Setup_Defaults = false;
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::DrawClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Draw_1->Enabled = Draw->Checked && BCB_Exists[BCB1];
Draw_3->Enabled = Draw->Checked && BCB_Exists[BCB3];
Draw_4->Enabled = Draw->Checked && BCB_Exists[BCB4];
Draw_5->Enabled = Draw->Checked && BCB_Exists[BCB5];
Draw_6->Enabled = Draw->Checked && BCB_Exists[BCB6];
if (Draw->Checked) Draw->Hint = "Remove the TDx_Draw_Library components from the selected BCB's.";
else Draw->Hint = "Do not remove the TDx_Draw_Library components at this time.";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::SoundClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Sound_1->Enabled = Sound->Checked && BCB_Exists[BCB1];
Sound_3->Enabled = Sound->Checked && BCB_Exists[BCB3];
Sound_4->Enabled = Sound->Checked && BCB_Exists[BCB4];
Sound_5->Enabled = Sound->Checked && BCB_Exists[BCB5];
Sound_6->Enabled = Sound->Checked && BCB_Exists[BCB6];
if (Sound->Checked) Sound->Hint = "Remove the TDx_Sound_Library components from the selected BCB's.";
else Sound->Hint = "Do not remove the TDx_Sound_Library components at this time.";
}
//---------------------------------------------------------------------------
void __fastcall TUnInstallSetupForm::InputClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Input_1->Enabled = Input->Checked && BCB_Exists[BCB1];
Input_3->Enabled = Input->Checked && BCB_Exists[BCB3];
Input_4->Enabled = Input->Checked && BCB_Exists[BCB4];
Input_5->Enabled = Input->Checked && BCB_Exists[BCB5];
Input_6->Enabled = Input->Checked && BCB_Exists[BCB6];
if (Input->Checked) Input->Hint = "Remove the TDx_Input_Library components from the selected BCB's.";
else Input->Hint = "Do not remove the TDx_Input_Library components at this time.";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::PlayClick(TObject *Sender)
{
if (Setting_Up_Links) return;
Play_1->Enabled = Play->Checked && BCB_Exists[BCB1];
Play_3->Enabled = Play->Checked && BCB_Exists[BCB3];
Play_4->Enabled = Play->Checked && BCB_Exists[BCB4];
Play_5->Enabled = Play->Checked && BCB_Exists[BCB5];
Play_6->Enabled = Play->Checked && BCB_Exists[BCB6];
if (Play->Checked) Play->Hint = "Remove the TDx_Play_Library components from the selected BCB's.";
else Play->Hint = "Do not remove the TDx_Play_Library components at this time.";
}
//---------------------------------------------------------------------------


void __fastcall TUnInstallSetupForm::d3IClick(TObject *Sender)
{
if (Setting_Up_Links) return;
d3I_1->Enabled = d3I->Checked && BCB_Exists[BCB1];
d3I_3->Enabled = d3I->Checked && BCB_Exists[BCB3];
d3I_4->Enabled = d3I->Checked && BCB_Exists[BCB4];
d3I_5->Enabled = d3I->Checked && BCB_Exists[BCB5];
d3I_6->Enabled = d3I->Checked && BCB_Exists[BCB6];
if (d3I->Checked) d3I->Hint = "Remove the TDx_3DI_Library components from the selected BCB's.";
else d3I->Hint = "Do not remove the TDx_3DI_Library components at this time.";
}
//---------------------------------------------------------------------------



void __fastcall TUnInstallSetupForm::BCBTools_AnimMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
MainForm->BCBTools_AnimMouseMove( this, Shift, X, Y );
}
//---------------------------------------------------------------------------


void __fastcall TUnInstallSetupForm::BCBToolsClick(TObject *Sender)
{
MainForm->BCBTools->OnClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::TitleClick(TObject *Sender)
{
MainForm->TitleClick(this);
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::RemoveSourceClick(TObject *Sender)
{
if (RemoveSource->Checked) RemoveSource->Hint = "Delete all the files in BCB directories associated with the selected libraries placed there during previous installs";
else RemoveSource->Hint = "Do not delete the files in BCB directories associated with the selected libraries";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::RemoveComponentsClick(TObject *Sender)
{
if (RemoveComponents->Checked) RemoveComponents->Hint = "Remove essential files for the selected component libraries from selected BCB environments";
else RemoveComponents->Hint = "Do not remove essential files for the selected component libraries";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::UnRegisterHelpClick(TObject *Sender)
{
if (UnRegisterHelp->Checked) UnRegisterHelp->Hint = "Un-Register (remove) the selected help files from selected BCB environments";
else UnRegisterHelp->Hint = "Do not remove the selected help files";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::RestoreDirectXClick(TObject *Sender)
{
if (RestoreDirectX->Checked) RestoreDirectX->Hint = "Restore the original DirectX files supplied with BCB and backed up during the install";
else RestoreDirectX->Hint = "Do not restore DirectX Include and Library files to BCB directories";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::DeleteAllClick(TObject *Sender)
{
if (DeleteAll->Checked) DeleteAll->Hint = "Delete all files previously extracted from the selected libraries .PIT files";
else DeleteAll->Hint = "Do not delete the files associated with the selected libraries";
}
//---------------------------------------------------------------------------

void __fastcall TUnInstallSetupForm::ForcedClick(TObject *Sender)
{
if (Forced->Checked) Forced->Hint = "Force the removal of any library, even a library that is not currently installed";
else Forced->Hint = "Only remove the libraries that are currently installed";

Draw->Checked = Forced->Checked;
Sound->Checked = Forced->Checked;
Input->Checked = Forced->Checked;
Play->Checked = Forced->Checked;
d3I->Checked = Forced->Checked;

Draw->Enabled = Forced->Checked;
Sound->Enabled = Forced->Checked;
Input->Enabled = Forced->Checked;
Play->Enabled = Forced->Checked;
d3I->Enabled = Forced->Checked;

for (int lib=0;lib<NUM_LIBS;lib++)
    for (int bcb=0;bcb<NUM_BCB;bcb++)
        {
        Library_CheckBoxes[lib][bcb]->Enabled = true;
        Library_CheckBoxes[lib][bcb]->Checked = true;
        }

UpdateCheckBoxes();
}
//---------------------------------------------------------------------------
void __fastcall TUnInstallSetupForm::FormShow(TObject *Sender)
{
Top = MainForm->Top;
Left = MainForm->Left;
Width = MainForm->Width;
Height = MainForm->Height;

UpdateCheckBoxes();

DrawClick(this);
SoundClick(this);
InputClick(this);
PlayClick(this);
d3IClick(this);
}
//---------------------------------------------------------------------------


void __fastcall TUnInstallSetupForm::UnRegisterComponentsClick(
      TObject *Sender)
{
if (UnRegisterComponents->Checked) UnRegisterComponents->Hint = "Un-Register (remove) the selected components from selected BCB environments";
else UnRegisterComponents->Hint = "Do not remove the selected components";
}
//---------------------------------------------------------------------------


void __fastcall TUnInstallSetupForm::Draw_1Click(TObject *Sender)
{
UpdateCheckBoxes();
}
//---------------------------------------------------------------------------

