//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TUpgradeForm.h"
#include "TMainForm.h"
#include "TInstallForm.h"
#include "stdio.h"
#include "fcntl.h"
#include "io.h"
#include "dir.h"
#include "clipbrd.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TDSBufferDesc"
#pragma link "TDx_SoundBuffer"
#pragma resource "*.dfm"
TUpgradeForm *UpgradeForm;
//---------------------------------------------------------------------------
#define Msg( str )               {\
                                    try {\
                                        Results->Lines->Add( (str) );\
                                        }\
                                    catch (Exception &e)\
                                        {\
                                        try {\
                                            Results->Lines->Clear();\
                                            Results->Lines->Add( (str) );\
                                            }\
                                        catch (Exception &e)\
                                            {\
                                            }\
                                        }\
                                    Results->Update();\
                                    }\
//---------------------------------------------------------------------------
AnsiString  ReplaceText( AnsiString SourceText,
                         AnsiString ReplaceWhat,
                         AnsiString WithWhat )
{
if (SourceText=="") return "";
if (ReplaceWhat=="") return SourceText;
if (ReplaceWhat==WithWhat) return SourceText;

AnsiString return_string = "";
int iter = 0;
int srce_pos = 1;
while ((srce_pos != 0) && (iter<1000000))
    {
    srce_pos = SourceText.Pos(  ReplaceWhat );
    if (srce_pos!=0)
        {
        return_string = return_string + SourceText.SubString( 1, srce_pos-1 ) + WithWhat;
        SourceText.Delete( 1, srce_pos-1 + ReplaceWhat.Length() );
        }
    else
        return_string = return_string + SourceText;
    iter++;
    }
return return_string;
}
//---------------------------------------------------------------------------
__fastcall TUpgradeForm::TUpgradeForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::FormShow(TObject *Sender)
{
Top = MainForm->Top;
Left = MainForm->Left;
Width = MainForm->Width;
Height = MainForm->Height;
try {
    DirectoryListBox1->Directory = TDx_Root_Dir;
    }
catch (...)
    {
    }
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::UpgradeMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
if (!Active) return;
TComponent* sender = (TComponent*) Sender;
if (sender==NULL) return;

// if there is an image that is already Highlighted, un-highlight it now.
if ((sender->Name!="Upgrade") && (Highlighted=="Upgrade")) { UpgradeImage->Picture = MainForm->Lo->Picture; Upgrade->Font->Color = clNavy; }
else if ((sender->Name!="Crossgrade") && (Highlighted=="Crossgrade")) { CrossgradeImage->Picture = MainForm->Lo->Picture; Crossgrade->Font->Color = clNavy; }
else if ((sender->Name!="Downgrade") && (Highlighted=="Downgrade")) { DowngradeImage->Picture = MainForm->Lo->Picture; Downgrade->Font->Color = clNavy; }
else if ((sender->Name!="Prev") && (Highlighted=="Prev")) { PrevImage->Picture = MainForm->Lo->Picture; Prev->Font->Color = clNavy; }
else if ((sender->Name!="Help") && (Highlighted=="Help")) { HelpImage->Picture = MainForm->Lo->Picture; Help->Font->Color = clNavy; }
else if ((sender->Name!="Exit") && (Highlighted=="Exit")) { ExitImage->Picture = MainForm->Lo->Picture; Exit->Font->Color = clNavy; }

// if the image is not already Highlighted, but now needs to be Highlighted....
if ((sender->Name=="Upgrade") && (Highlighted != "Upgrade")) { UpgradeImage->Picture = MainForm->Hi->Picture; Upgrade->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Crossgrade") && (Highlighted != "Crossgrade")) { CrossgradeImage->Picture = MainForm->Hi->Picture; Crossgrade->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Downgrade") && (Highlighted != "Downgrade")) { DowngradeImage->Picture = MainForm->Hi->Picture; Downgrade->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Prev") && (Highlighted != "Prev")) { PrevImage->Picture = MainForm->Hi->Picture; Prev->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Help") && (Highlighted != "Help")) { HelpImage->Picture = MainForm->Hi->Picture; Help->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }
else if ((sender->Name=="Exit") && (Highlighted != "Exit")) { ExitImage->Picture = MainForm->Hi->Picture; Exit->Font->Color = clWhite; if (MainForm->Pop->Playing) MainForm->Pop->Stop(); MainForm->Pop->Play(0,0); }

// remember which button is Highlighted
Highlighted = sender->Name;
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::FormPaint(TObject *Sender)
{
Canvas->Brush->Color = clBlack;
Canvas->Brush->Style = bsSolid;
Canvas->FrameRect( ClientRect );
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::FormCreate(TObject *Sender)
{
Mode = "";
upgrading = false;
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::FormHide(TObject *Sender)
{
Results->Lines->Text = "\n\
(1) Move cursor over options, wait, look at hints.\n\
(2) Select directory\n\
(3) Click preferred option.\n";
CopiedLabel->Caption = "( Copy text to Clipboard )";
}
//---------------------------------------------------------------------------

void __fastcall TUpgradeForm::PrevClick(TObject *Sender)
{
if (MainForm->Prev->Playing) MainForm->Prev->Stop();
MainForm->Prev->Play(0,0);
Close();
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::SpeedButton1Click(TObject *Sender)
{
TClipboard* clip = Clipboard();
clip->AsText = Results->Lines->Text;
CopiedLabel->Caption = "( copied )";
CopiedLabel->Update();
Application->HandleMessage();
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::BCBTools_AnimMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
MainForm->BCBTools_AnimMouseMove( this, Shift, X, Y );
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::BCBToolsClick(TObject *Sender)
{
MainForm->BCBTools->OnClick(this);
}
//---------------------------------------------------------------------------


void __fastcall TUpgradeForm::TitleClick(TObject *Sender)
{
MainForm->Title->OnClick(this);
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::UpdateDirectoryTree( AnsiString root )
{
Application->HandleMessage();
if (!upgrading) return;

//      int iAttributes = 0;
//      iAttributes |= faReadOnly;
//      iAttributes |= faHidden * CheckBox2->Checked;
//      iAttributes |= faSysFile * CheckBox3->Checked;
//      iAttributes |= faVolumeID * CheckBox4->Checked;
//      iAttributes |= faDirectory * CheckBox5->Checked;
//      iAttributes |= faArchive * CheckBox6->Checked;
//      iAttributes |= faAnyFile * CheckBox7->Checked;

AnsiString original_directory = GetCurrentDir();
bool dir_changed = SetCurrentDir( root );

Directory->Caption = "Scanning: "+original_directory;
Directory->Update();
Msg( Directory->Caption );

TSearchRec search_record;
int attributes = faAnyFile;
if (FindFirst("*.*", attributes, search_record) == 0)
    {
    do
        {
        Application->ProcessMessages();
        if (!upgrading) break;

        if ((search_record.Attr & faDirectory) == faDirectory)
            {
            AnsiString directory = search_record.Name;
            if ((directory==".") || (directory=="..")) continue;
            UpdateDirectoryTree( root+"\\"+directory );
            }
        else
            {
            AnsiString filename = search_record.Name.UpperCase();

            if ((filename.Pos(".MAK")==filename.Length()-3) ||
                (filename.Pos(".BPR")==filename.Length()-3))
                {
                TStringList* strings = new TStringList();
                if (strings)
                    {
                    try {
                        strings->LoadFromFile( GetCurrentDir()+"\\"+filename );
                        AnsiString original = strings->Text;

                        // cleanup for all modes
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Lib\\BCB1;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Lib\\BCB3;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Lib\\BCB4;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Lib\\BCB5;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Lib\\Dx61;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Lib\\Dx7;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Include\\BCB1;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Include\\BCB3;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Include\\BCB4;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Include\\BCB5;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Include\\Dx61;", "" );
                        strings->Text = ReplaceText( strings->Text, "..\\..\\..\\..\\Include\\Dx7;", "" );
                        strings->Text = ReplaceText( strings->Text, "/i..\\..\\..\\..\\Include\\BCB1 ", "" );
                        strings->Text = ReplaceText( strings->Text, "/i..\\..\\..\\..\\Include\\BCB3 ", "" );
                        strings->Text = ReplaceText( strings->Text, "/i..\\..\\..\\..\\Include\\BCB4 ", "" );
                        strings->Text = ReplaceText( strings->Text, "/i..\\..\\..\\..\\Include\\BCB5 ", "" );
                        strings->Text = ReplaceText( strings->Text, "/i..\\..\\..\\..\\Include\\Dx61 ", "" );
                        strings->Text = ReplaceText( strings->Text, "/i..\\..\\..\\..\\Include\\Dx7 ", "" );

                        if (Mode=="Crossgrade")
                            {
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB1;..\\..\\..\\..\\Lib\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB3;..\\..\\..\\..\\Lib\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB4;..\\..\\..\\..\\Lib\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB5;..\\..\\..\\..\\Lib\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB1;..\\..\\..\\..\\Include\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB3;..\\..\\..\\..\\Include\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB4;..\\..\\..\\..\\Include\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB5;..\\..\\..\\..\\Include\\Dx7;" );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB1 /i..\\..\\..\\..\\Include\\Dx7 " );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB3 /i..\\..\\..\\..\\Include\\Dx7 " );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB4 /i..\\..\\..\\..\\Include\\Dx7 " );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB5 /i..\\..\\..\\..\\Include\\Dx7 " );
                            }
                        if (Mode=="Downgrade")
                            {
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB1;..\\..\\..\\..\\Lib\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB3;..\\..\\..\\..\\Lib\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB4;..\\..\\..\\..\\Lib\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Lib\\BCB5;..\\..\\..\\..\\Lib\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB1;..\\..\\..\\..\\Include\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB3;..\\..\\..\\..\\Include\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB4;..\\..\\..\\..\\Include\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "..\\Source;", "..\\Source;..\\..\\..\\..\\Include\\BCB5;..\\..\\..\\..\\Include\\Dx61;" );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB1 /i..\\..\\..\\..\\Include\\Dx61 " );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB3 /i..\\..\\..\\..\\Include\\Dx61 " );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB4 /i..\\..\\..\\..\\Include\\Dx61 " );
                            strings->Text = ReplaceText( strings->Text, "/i..\\Source ", "/i..\\Source /i..\\..\\..\\..\\Include\\BCB5 /i..\\..\\..\\..\\Include\\Dx61 " );
                            }

                        if (strings->Text != original)
                            {
                            AnsiString temp = strings->Text;

                            strings->Text = original;
                            strings->SaveToFile( GetCurrentDir()+"\\"+filename+".TDX" );
                            Msg("Backup : "+GetCurrentDir()+"\\"+filename+".TDX" );

                            strings->Text = temp;
                            strings->SaveToFile( GetCurrentDir()+"\\"+filename );
                            Msg(Mode+"d: "+GetCurrentDir()+"\\"+filename);
                            }
                        else
                            {
                            Msg("Skipped: "+GetCurrentDir()+"\\"+filename);
                            }
                        }
                    catch (...)
                        {
                        Msg("Failed : "+GetCurrentDir()+"\\"+filename);
                        }
                    delete strings;
                    }
                }
            }
        }
    while ((FindNext(search_record) == 0) && (upgrading));
    FindClose(search_record);
    }

if (dir_changed)
    SetCurrentDir( original_directory );
}
//---------------------------------------------------------------------------
void __fastcall TUpgradeForm::UpgradeClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);

if (upgrading)
    {
    if (MainForm->InstallWav->Playing) MainForm->InstallWav->Stop();

    upgrading = false;
    Mode = "";

    Upgrade->Caption = "upgrade";
    Upgrade->Update();
    Msg("----");
    Msg("Done.");
    try {
        Results->Lines->SaveToFile( GetCurrentDir() + "\\" + "TDx_Upgrade.LOG" );
        Msg("----");
        Msg("Results Saved to File: "+GetCurrentDir() + "\\" + "TDx_Upgrade.LOG" );
        }
    catch (...)
        {
        }

    Upgrade->Visible = true;
    UpgradeImage->Visible = true;
    Crossgrade->Visible = true;
    CrossgradeImage->Visible = true;
    Downgrade->Visible = true;
    DowngradeImage->Visible = true;
    Prev->Visible = true;
    PrevImage->Visible = true;
    Help->Visible = true;
    HelpImage->Visible = true;
    Exit->Visible = true;
    ExitImage->Visible = true;
    ExitHere->Visible = true;
    }
else
    {
    MainForm->InstallWav->Play(0,DSBPLAY_LOOPING);

    upgrading = true;
    Mode = "Upgrade";
    Upgrade->Caption = "[] STOP";
    Upgrade->Update();

    Upgrade->Visible = true;
    UpgradeImage->Visible = true;
    Crossgrade->Visible = false;
    CrossgradeImage->Visible = false;
    Downgrade->Visible = false;
    DowngradeImage->Visible = false;
    Prev->Visible = false;
    PrevImage->Visible = false;
    Help->Visible = false;
    HelpImage->Visible = false;
    Exit->Visible = false;
    ExitImage->Visible = false;
    ExitHere->Visible = false;

    CopiedLabel->Caption = "( Copy text to Clipboard )";
    CopiedLabel->Visible = false;
    SpeedButton1->Visible = false;
    Application->HandleMessage();

    Results->Lines->Clear();
    Msg("----");
    Msg("Scanning and Updating .MAK and .BPR Project Files to fit TDx_Library v1.4+");
    Msg("----");
    UpdateDirectoryTree( DirectoryListBox1->Directory );
    if (upgrading) UpgradeClick(this);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUpgradeForm::ExitClick(TObject *Sender)
{
if (MainForm->Goodbye->Play(0,0))
while (MainForm->Goodbye->Playing) ;  // wait for end playing
Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TUpgradeForm::CrossgradeClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);

if (upgrading)
    {
    if (MainForm->InstallWav->Playing) MainForm->InstallWav->Stop();

    upgrading = false;
    Mode = "";
    Crossgrade->Caption = "crossgrade";
    Crossgrade->Update();
    Msg("----");
    Msg("Done.");
    try {
        Results->Lines->SaveToFile( GetCurrentDir() + "\\" + "TDx_Crossgrade.LOG" );
        Msg("----");
        Msg("Results Saved to File: "+GetCurrentDir() + "\\" + "TDx_Crossgrade.LOG" );
        }
    catch (...)
        {
        }
    Upgrade->Visible = true;
    UpgradeImage->Visible = true;
    Crossgrade->Visible = true;
    CrossgradeImage->Visible = true;
    Downgrade->Visible = true;
    DowngradeImage->Visible = true;
    Prev->Visible = true;
    PrevImage->Visible = true;
    Help->Visible = true;
    HelpImage->Visible = true;
    Exit->Visible = true;
    ExitImage->Visible = true;
    ExitHere->Visible = true;
    }
else
    {
    MainForm->InstallWav->Play(0,DSBPLAY_LOOPING);
    
    upgrading = true;
    Mode = "Crossgrade";
    Crossgrade->Caption = "[] STOP";
    Crossgrade->Update();

    Upgrade->Visible = false;
    UpgradeImage->Visible = false;
    Crossgrade->Visible = true;
    CrossgradeImage->Visible = true;
    Downgrade->Visible = false;
    DowngradeImage->Visible = false;
    Prev->Visible = false;
    PrevImage->Visible = false;
    Help->Visible = false;
    HelpImage->Visible = false;
    Exit->Visible = false;
    ExitImage->Visible = false;
    ExitHere->Visible = false;

    CopiedLabel->Caption = "( Copy text to Clipboard )";
    CopiedLabel->Visible = false;
    SpeedButton1->Visible = false;
    Application->HandleMessage();

    Results->Lines->Clear();
    Msg("----");
    Msg("Scanning and Updating .MAK and .BPR Project Files to fit TDx_Library < v1.40");
    Msg("----");
    UpdateDirectoryTree( DirectoryListBox1->Directory );
    if (upgrading) CrossgradeClick(this);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUpgradeForm::DowngradeClick(TObject *Sender)
{
if (MainForm->Next->Playing) MainForm->Next->Stop();
MainForm->Next->Play(0,0);

if (upgrading)
    {
    if (MainForm->InstallWav->Playing) MainForm->InstallWav->Stop();

    upgrading = false;
    Mode = "";
    Downgrade->Caption = "downgrade";
    Downgrade->Update();
    Msg("----");
    Msg("Done.");
    try {
        Results->Lines->SaveToFile( GetCurrentDir() + "\\" + "TDx_Downgrade.LOG" );
        Msg("----");
        Msg("Results Saved to File: "+GetCurrentDir() + "\\" + "TDx_Downgrade.LOG" );
        }
    catch (...)
        {
        }
    Upgrade->Visible = true;
    UpgradeImage->Visible = true;
    Crossgrade->Visible = true;
    CrossgradeImage->Visible = true;
    Downgrade->Visible = true;
    DowngradeImage->Visible = true;
    Prev->Visible = true;
    PrevImage->Visible = true;
    Help->Visible = true;
    HelpImage->Visible = true;
    Exit->Visible = true;
    ExitImage->Visible = true;
    ExitHere->Visible = true;
    }
else
    {
    MainForm->InstallWav->Play(0,DSBPLAY_LOOPING);

    upgrading = true;
    Mode = "Downgrade";
    Downgrade->Caption = "[] STOP";
    Downgrade->Update();

    Upgrade->Visible = false;
    UpgradeImage->Visible = false;
    Crossgrade->Visible = false;
    CrossgradeImage->Visible = false;
    Downgrade->Visible = true;
    DowngradeImage->Visible = true;
    Prev->Visible = false;
    PrevImage->Visible = false;
    Help->Visible = false;
    HelpImage->Visible = false;
    Exit->Visible = false;
    ExitImage->Visible = false;
    ExitHere->Visible = false;

    CopiedLabel->Caption = "( Copy text to Clipboard )";
    CopiedLabel->Visible = false;
    SpeedButton1->Visible = false;
    Application->HandleMessage();

    Results->Lines->Clear();
    Msg("----");
    Msg("Scanning and Updating .MAK and .BPR Project Files to fit TDx_Library <= v1.10, dx6.1");
    Msg("----");
    UpdateDirectoryTree( DirectoryListBox1->Directory );
    if (upgrading) DowngradeClick(this);
    }
}
//---------------------------------------------------------------------------

void __fastcall TUpgradeForm::HelpClick(TObject *Sender)
{
Error("This upgrade feature allows you to :-\n\
\n\
(1) Upgrade a single BCB project\n\
(2) Upgrade an entire BCB project directory tree\n\
\n\
----\n\
\n\
Using this feature you can :-\n\
\n\
(1) Upgrade existing BCB projects to use TDx_Library v1.4+\n\
(2) Crossgrade existing BCB projects to use early Dx7 versions of the TDx_Library (v1.30, v1.20, v1.10)\n\
(3) Downgrade existing BCB projects to use early Dx61 versions of the TDx_Library (v1.10, v1.01)\n\
\n\
After upgrading of BCB project(s), you will need to code changes required to accomodate each individual library version.\n\
\n\
Similarly, to compile you will need to install / uninstall the individual versions of the TDx_Library components.\n\
\n\
----\n\
\n\
To manually setup your existing TDx_Library project, use the following steps :-\n\
\n\
  (1) For each of your existing TDx_Library projects\n\
  (2) Tools->Environment Options->Library->\n\
      * note: for BCB1 it's Options->Environment->Library->\n\
\n\
      * TO UPGRADE: (dx7, TDx_Library v1.40++)\n\
        for the Library Path, remove entirely any references like:\n\
\n\
          \"\\TDx_Library\\Lib\\BCB[X]\" and\n\
          \"\\TDx_Library\\Lib\\Dx7\" and\n\
          \"\\TDx_Library\\Include\\BCB[X]\" and\n\
          \"\\TDx_Library\\Include\\Dx7\"\n\
\n\
      * TO CROSSGRADE: (dx7, TDx_Library < v1.40) \n\
        for the Library Path, add relevant details, so it is like:\n\
\n\
          \"D:\\TDx_Library\\Lib\\BCB5;D:\\TDx_Library\\Lib\\Dx7;($BCB)\\Lib;($BCB)\\Lib\\Obj;\"\n\
\n\
      * TO DOWNGRADE: (dx61, TDx_Library ~= v1.10, v1.01) \n\
        for the Library Path, add relevant details, so it is like:\n\
\n\
          \"D:\\TDx_Library\\Lib\\BCB5;D:\\TDx_Library\\Lib\\Dx61;($BCB)\\Lib;($BCB)\\Lib\\Obj;\"\n\
\n\
  (3) Project->Options->Directories/Conditionals->\n\
\n\
      * TO UPGRADE: (dx7, TDx_Library v1.40++)\n\
        for both the Include & Lib Paths, remove entirely any references like:\n\
\n\
          \"\\TDx_Library\\Lib\\BCB[X]\" and\n\
          \"\\TDx_Library\\Lib\\Dx7\" and\n\
          \"\\TDx_Library\\Include\\BCB[X]\" and\n\
          \"\\TDx_Library\\Include\\Dx7\"\n\
\n\
      * TO CROSSGRADE: (dx7, TDx_Library < v1.40) \n\
        for both the Include & Lib Paths, add references like:\n\
\n\
          \"\\TDx_Library\\Lib\\BCB[X]\" and\n\
          \"\\TDx_Library\\Lib\\Dx7\" and\n\
          \"\\TDx_Library\\Include\\BCB[X]\" and\n\
          \"\\TDx_Library\\Include\\Dx7\"\n\
\n\
        so the :Include Path: looks like:\n\
          \"D:\\TDx_Library\\Include\\BCB5;D:\\TDx_Library\\Include\\Dx7;($BCB)\\Include;($BCB)\\Include\\vcl;\"\n\
\n\
        and so the :Library Path: looks like:\n\
          \"D:\\TDx_Library\\Lib\\BCB5;D:\\TDx_Library\\Lib\\Dx7;($BCB)\\Lib;($BCB)\\Lib\\Obj;\"\n\
\n\
        [ note: Make sure you add the extra path details to the start of each row. ]\n\
\n\
      * TO DOWNGRADE: (dx61, TDx_Library ~= v1.10, v1.01) \n\
        for both the Include & Lib Paths, add references like:\n\
\n\
          \"\\TDx_Library\\Lib\\BCB[X]\" and\n\
          \"\\TDx_Library\\Lib\\Dx61\" and\n\
          \"\\TDx_Library\\Include\\BCB[X]\" and\n\
          \"\\TDx_Library\\Include\\Dx61\"\n\
\n\
        so the :Include Path: looks like:\n\
          \"D:\\TDx_Library\\Include\\BCB5;D:\\TDx_Library\\Include\\Dx61;($BCB)\\Include;($BCB)\\Include\\vcl;\"\n\
\n\
        and so the :Library Path: looks like:\n\
          \"D:\\TDx_Library\\Lib\\BCB5;D:\\TDx_Library\\Lib\\Dx61;($BCB)\\Lib;($BCB)\\Lib\\Obj;\"\n\
\n\
        [ note: Make sure you add the extra path details to the start of each row. ]\n\
\n\
  (4) Project->Save All\n\
  (5) Close BCB\n\
  (6) Done.");
ErrorOccurred = false;
}
//---------------------------------------------------------------------------

