//---------------------------------------------------------------------------
void __fastcall TUnInstallForm::UnInstallBCB1( int lib )
{
TRegistry* registry = new TRegistry();
if (registry==NULL)
    {
    Error( "\
--------------------------------------------\n\
BCB1 Remove Components Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 components cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB1_1\
\n\
--------------------------------------------\n\
" );
    return;
    }
registry->LazyWrite = false;
registry->RootKey = HKEY_CURRENT_USER;

try
    {
    // note:
    // BCB1 stores it's component palette in a file called cmplib32.ccl
    // (it's much like a large .obj or .lib file)
    // This cmplib32.ccl file is stored statically between builds and must be
    // recompiled by BCB1.
    // There is really nothing much we can install into BCB1, except to tell the
    // palette what it should compile next time.

    // add what we can to the component palette
    if (registry->OpenKey( BCB_Keys[BCB1]+"\\cmplib32.ccl.Palette", false ))
        registry->DeleteValue( Library_Abbrevs[lib] );
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB1 Remove Components Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 components cannot be removed because registry entries for BCB1 have been corrupted.\n\
You may need to reinstall or reconfigure BCB1 to correct this problem.\n\
\n\
Error Code: RBCB1_2\
\n\
--------------------------------------------\n\
" );
    }
delete registry;
}

