void __fastcall TUnInstallForm::UnInstallBCB1Help( int lib )
{
// remove libraries from BCB1 help
//
// load /CBuilder/Help/bcbhelp.cfg,
//   remove :INDEX && :LINK fields
//   if (modified) save modified bcbhelp.cfg
//
// delete files /CBuilder/Help/BCB.GID & /CBuilder/Help/BCB.FTS

// allocate temporary strings
TStringList* old_strings = new TStringList();
if (!old_strings)
    {
    Error( "\
--------------------------------------------\n\
BCB1 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 help files cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB1_H1\
\n\
--------------------------------------------\n\
" );
    return;
    }

TStringList* new_strings = new TStringList();
if (!new_strings)
    {
    Error( "\
--------------------------------------------\n\
BCB1 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 help files cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB1_H2\
\n\
--------------------------------------------\n\
" );
    delete old_strings;
    return;
    }

// some vars used below
bool found_link = false;
bool found_index = false;
int link_index = -1;
int index_index = -1;
bool removed_link = false;
bool removed_index = false;

// load contents of BCBHELP.CFG file
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG" ); }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB1 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 help files cannot be removed because an error occurred while reading the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG\"\n\
\n\
Error Code: RBCB1_H3\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// modify BCBHELP.CFG
try
    {
    // scan all existing rows to see what is already uninstalled
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :INDEX row
        if (st.Pos( ":INDEX" )!=0)
            // also check for a complete :INDEX TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_index = true;
                index_index =  i;
                }
        // remember the last :LINK row
        if (st.Pos( ":LINK" )!=0)
            // also check for a complete :LINK TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_link = true;
                link_index =  i;
                break;
                }
        }

    // now do the actual copy, removing existing :INDEX, :LINK as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        bool add = true;
        if (found_index && (i==index_index)) { add = false; removed_index = true; }
        if (found_link && (i==link_index)) { add = false; removed_link = true; }
        if (add) new_strings->Add( old_strings->Strings[i] );
        }
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB1 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG\"\n\
\n\
Error Code: RBCB1_H4\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// save changes to file
if (removed_index || removed_link)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG" );
        }
    catch (...)
        {
        Error( "\
--------------------------------------------\n\
BCB1 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB1 help files cannot be removed because a file could not be modified:\n\
\n\
    \""+BCB_Root_Dirs[BCB1]+"\\Help\\BCBHelp.CFG\"\n\
\n\
Error Code: RBCB1_H5\
\n\
--------------------------------------------\n\
" );
        delete old_strings;
        delete new_strings;
        return;
        }

// cleanup temporary strings
delete new_strings;
delete old_strings;

// make BCB re-link the HELP by deleting the following files.
DeleteFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCB.GID" );
DeleteFile( BCB_Root_Dirs[BCB1]+"\\Help\\BCB.FTS" );
}
