void __fastcall TUnInstallForm::UnInstallBCB4Help( int lib )
{
// remove libraries from BCB4 help
//
// load /CBuilder4/Help/bcb4.ohc,
//   remove :INCLUDE TDX_DRAW_LIBRARY field
//   if (modified) save modified bcb4.ohc
//
// load /CBuilder4/Help/bcb4.ohi,
//   remove :INCLUDE TDX_DRAW_LIBRARY field
//   if (modified) save modified bcb4.ohi
//
// delete files /CBuilder4/Help/BCB4.GID & /CBuilder4/Help/BCB4.FTS

// allocate temporary strings
TStringList* old_strings = new TStringList();
if (!old_strings)
    {
    Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB4_H1\
\n\
--------------------------------------------\n\
" );
    return;
    }

TStringList* new_strings = new TStringList();
if (!new_strings)
    {
    Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB4_H2\
\n\
--------------------------------------------\n\
" );
    delete old_strings;
    return;
    }

// some vars used below
bool found_index = false;
bool found_include = false;
int index_index = -1;
int include_index = -1;
bool removed_index = false;
bool removed_include = false;

// -----------------------------
// load contents of BCB4.OHC file
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHC" );
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because an error occurred while reading the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHC\"\n\
\n\
Error Code: RBCB4_H4\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// modify BCB4.OHC
try
    {
    // scan all existing rows to see what is already uninstalled
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :INCLUDE row
        if (st.Pos( ":INCLUDE" )!=0)
            // also check for a complete :INCLUDE TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_include = true;
                include_index =  i;
                }
        }

    // now do the actual copy, removing existing :INCLUDEs as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        bool add = true;
        if (found_include && (i==include_index)) { add = false; removed_include = true; }
        if (add) new_strings->Add( old_strings->Strings[i] );
        }
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHC\"\n\
\n\
Error Code: RBCB4_H5\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// save changes to file BCB4.OHC
if (removed_include)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHC" );
        }
    catch (...)
        {
        Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because a file could not be modified:\n\
\n\
    \""+BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHC\"\n\
\n\
Error Code: RBCB4_H6\
\n\
--------------------------------------------\n\
" );
        delete old_strings;
        delete new_strings;
        return;
        }


// -----------------------------
// load contents of BCB4.OHI file
new_strings->Clear();
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHI" ); }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHI\"\n\
\n\
Error Code: RBCB4_H7\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// modify BCB4.OHI
try
    {
    // scan all existing rows to see what is already uninstalled
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :INDEX row
        if (st.Pos( ":INDEX" )!=0)
            // also check for a complete :INDEX TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_index = true;
                index_index =  i;
                }
        }
    // now do the actual copy, removing existing :INDEXs as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        bool add = true;
        if (found_index && (i==index_index)) { add = false; removed_index = true; }
        if (add) new_strings->Add( old_strings->Strings[i] );
        }
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHI\"\n\
\n\
Error Code: RBCB4_H8\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// save changes to file BCB4.OHI
if (removed_index)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHI" );
        }
    catch (...)
        {
        Error( "\
--------------------------------------------\n\
BCB4 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB4 help files cannot be removed because a file could not be modified:\n\
\n\
    \""+BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.OHI\"\n\
\n\
Error Code: RBCB4_H9\
\n\
--------------------------------------------\n\
" );
        delete old_strings;
        delete new_strings;
        return;
        }

// cleanup temporary strings
delete new_strings;
delete old_strings;

// make BCB re-link the HELP by deleting the following files.
DeleteFile( BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.GID" );
DeleteFile( BCB_Root_Dirs[BCB4]+"\\Help\\BCB4.FTS" );
}
