//---------------------------------------------------------------------------
void __fastcall TUnInstallForm::UnInstallBCB5( int lib )
{
TRegistry* registry = new TRegistry();
if (registry==NULL)
    {
    Error( "\
--------------------------------------------\n\
BCB5 Remove Components Problem:\n\
--------------------------------------------\n\
\n\
The BCB5 components cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB5_1\
\n\
--------------------------------------------\n\
" );
    return;
    }
registry->LazyWrite = false;
registry->RootKey = HKEY_CURRENT_USER;

TStringList* strings = new TStringList();
if (strings==NULL)
    {
    Error( "\
--------------------------------------------\n\
BCB5 Remove Components Problem:\n\
--------------------------------------------\n\
\n\
The BCB5 components cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB5_2\
\n\
--------------------------------------------\n\
" );
    delete registry;
    return;
    }

try
    {
    // note:
    // BCB5 stores it's component palette in the system registry and can be
    // modified easily. Simply insert and modify the appropriate keys.
    // Next time BCB5 starts, the new components will be installed
    // note: also need to add all TDx_ references to Known + Disabled Packages key

    // remove from component palette
    // eg. "TDx_Draw"->"TDx_Draw;TDx_DrawClipper;TDx_DrawColorControl;etc."
    registry->OpenKey( BCB_Keys[BCB5]+"\\Palette", false );
    registry->DeleteValue( Library_Abbrevs[BCB5] );

    // modify disabled packages
    registry->OpenKey( BCB_Keys[BCB5]+"\\Disabled Packages", false );
    registry->GetValueNames( strings );
    for (int i=0;i<strings->Count;i++)
        if (strings->Strings[i].Pos(Library_Names[lib])!=0)
            registry->DeleteValue( strings->Strings[i] );

    // modify known packages
    registry->OpenKey( BCB_Keys[BCB5]+"\\Known Packages", false );
    registry->GetValueNames( strings );
    for (int i=0;i<strings->Count;i++)
        if (strings->Strings[i].Pos(Library_Names[lib])!=0)
            registry->DeleteValue( strings->Strings[i] );
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB5 Remove Components Problem:\n\
--------------------------------------------\n\
\n\
The BCB5 components cannot be removed because registry entries for BCB5 have been corrupted.\n\
You may need to reinstall or reconfigure BCB5 to correct this problem.\n\
\n\
Error Code: RBCB5_3\
\n\
---------------------------\n\
" );
    }
delete strings;
delete registry;
}
