void __fastcall TUnInstallForm::UnInstallBCB6Help( int lib )
{
// remove libraries from BCB6 help
//
// load /CBuilder6/Help/bcb6.ohl,
//   remove :LINK TDX_DRAW_LIBRARY field
//   if (modified) save modified BCB6.OHL
//
// load /CBuilder6/Help/bcb6.ohi,
//   remove :INCLUDE TDX_DRAW_LIBRARY field
//   if (modified) save modified BCB6.OHI
//
// delete files /CBuilder6/Help/BCB6.GID & /CBuilder6/Help/BCB6.FTS

// allocate temporary strings
TStringList* old_strings = new TStringList();
if (!old_strings)
    {
    Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB6_H1\
\n\
--------------------------------------------\n\
" );
    return;
    }

TStringList* new_strings = new TStringList();
if (!new_strings)
    {
    Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because there is not enough memory available for use by this application.\n\
Try reducing the number of applications you currently have open, or buy more memory.\n\
\n\
Error Code: RBCB6_H2\
\n\
--------------------------------------------\n\
" );
    delete old_strings;
    return;
    }

// some vars used below
bool found_index = false;
bool found_include = false;
int index_index = -1;
int include_index = -1;
bool removed_index = false;
bool removed_include = false;

// -----------------------------
// load contents of BCB6.OHL file
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL" );
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because an error occurred while reading the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL\"\n\
\n\
Error Code: RBCB6_H4\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// modify BCB6.OHL
try
    {
    // scan all existing rows to see what is already uninstalled
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :LINK row
        if (st.Pos( ":LINK" )!=0)
            // also check for a complete :LINK TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_include = true;
                include_index =  i;
                }
        }

    // now do the actual copy, removing existing :LINKs as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        bool add = true;
        if (found_include && (i==include_index)) { add = false; removed_include = true; }
        if (add) new_strings->Add( old_strings->Strings[i] );
        }
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL\"\n\
\n\
Error Code: RBCB6_H5\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// save changes to file BCB6.OHL
if (removed_include)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL" );
        }
    catch (...)
        {
        Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because a file could not be modified:\n\
\n\
    \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHL\"\n\
\n\
Error Code: RBCB6_H6\
\n\
--------------------------------------------\n\
" );
        delete old_strings;
        delete new_strings;
        return;
        }


// -----------------------------
// load contents of BCB6.OHI file
new_strings->Clear();
try
    {
    old_strings->LoadFromFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI" ); }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI\"\n\
\n\
Error Code: RBCB6_H7\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// modify BCB6.OHI
try
    {
    // scan all existing rows to see what is already uninstalled
    for (int i=0;i<old_strings->Count;i++)
        {
        AnsiString st = old_strings->Strings[i].UpperCase();
        // remember the last :INDEX row
        if (st.Pos( ":INDEX" )!=0)
            // also check for a complete :INDEX TDx_Draw_Library row
            if (st.Pos( Library_Names[lib].UpperCase() )!=0)
                {
                found_index = true;
                index_index =  i;
                }
        }
    // now do the actual copy, removing existing :INDEXs as we go
    for (int i=0;i<old_strings->Count;i++)
        {
        bool add = true;
        if (found_index && (i==index_index)) { add = false; removed_index = true; }
        if (add) new_strings->Add( old_strings->Strings[i] );
        }
    }
catch (...)
    {
    Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because an error occurred while parsing the file:\n\
\n\
    \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI\"\n\
\n\
Error Code: RBCB6_H8\n\
\n\
--------------------------------------------\n\
" );
    delete new_strings;
    delete old_strings;
    return;
    }

// save changes to file BCB6.OHI
if (removed_index)
    try
        {
        new_strings->SaveToFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI" );
        }
    catch (...)
        {
        Error( "\
--------------------------------------------\n\
BCB6 Remove Help Files Problem:\n\
--------------------------------------------\n\
\n\
The BCB6 help files cannot be removed because a file could not be modified:\n\
\n\
    \""+BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.OHI\"\n\
\n\
Error Code: RBCB6_H9\n\
\n\
--------------------------------------------\n\
" );
        delete old_strings;
        delete new_strings;
        return;
        }

// cleanup temporary strings
delete new_strings;
delete old_strings;

// make BCB re-link the HELP by deleting the following files.
DeleteFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.GID" );
DeleteFile( BCB_Root_Dirs[BCB6]+"\\Help\\BCB6.FTS" );
}
